//This script is by Alex Turtle
//Vscript Battleroyale for TF2 "Squad Showdown" version 1.0.0

::SCRIPT_VERSION <- "1.0.0"

IncludeScript("battleroyale/glowlocal.nut")
IncludeScript("battleroyale/give_tf_weapon/_master.nut")
IncludeScript("battleroyale/battleroyale_weapon_manager.nut")
IncludeScript("battleroyale/config/rarity.nut")
IncludeScript("battleroyale/battleroyale_weapon.nut")
IncludeScript("battleroyale/battleroyale_mannpower.nut")
IncludeScript("battleroyale/battleroyale_events.nut")
IncludeScript("battleroyale/battleroyale_cash.nut")
IncludeScript("battleroyale/battleroyale_utils.nut")
IncludeScript("battleroyale/battleroyale_player.nut")
IncludeScript("battleroyale/battleroyale_gamemodes.nut")
IncludeScript("battleroyale/battleroyale_player_interactions.nut")
IncludeScript("battleroyale/config/general.nut")
IncludeScript("battleroyale/config/crates.nut")
IncludeScript("battleroyale/config/weapons.nut")
IncludeScript("battleroyale/json.nut")

//Do not touch these
::worldspawn <- Entities.FindByClassname(null, "worldspawn");

::BR_DELETEWEAPONS <- false
::BR_SQUADSARRAY <- null
::BR_SQUADSALIVE <- null

::BR_MODE_TEAMS <- false

::BR_REFUND_PHASE <- true

::BR_ISENABLED <- false

::BR_END_PHASE <- false

::EarlyDeathRespawn <- true
::RevivesEnabled <- false
::CratesEnabled <- false

function Precache()
{
    PrecacheEverything()
    //EntFire("info_player_teamspawn", "disable", null, -1)

    if (IsInWaitingForPlayers())
    {
        Convars.SetValue("tf_classlimit", 0)
        Convars.SetValue("mp_disable_respawn_times", 0)
        Convars.SetValue("tf_dropped_weapon_lifetime", 0)
        Convars.SetValue("mp_scrambleteams_auto_windifference", 0)
        Convars.SetValue("mp_winlimit", 0)
        Convars.SetValue("mp_maxrounds", 0)
        Convars.SetValue("tf_stalematechangeclasstime", casti2f(0x7fa00000)) //NaN.
        Convars.SetValue("mp_teams_unbalance_limit", 0)
        Convars.SetValue("tf_scout_air_dash_count", 0)
        Convars.SetValue("tf_weapon_criticals", 0)
        Convars.SetValue("mp_respawnwavetime", 0)
        Convars.SetValue("mp_waitingforplayers_time", 90)
        Convars.SetValue("mp_friendlyfire", 1)
        Convars.SetValue("mp_humans_must_join_team", "red")
        Convars.SetValue("mp_autobalance", 0)
    }
    else
    {
        Convars.SetValue("mp_autobalance", 0)
        Convars.SetValue("mp_forcecamera", 0)
        Convars.SetValue("mp_stalemate_timelimit", 9999999)
        Convars.SetValue("mp_respawnwavetime", 9999999)

        local player = null
        if (player = Entities.FindByClassname(player, "player"))
            StartBattleRoyale()
    }
}

function OnPostSpawn()
{

    SetCenterPoint()

    if (IsInWaitingForPlayers())
    {
        Convars.SetValue("mp_waitingforplayers_restart", 1)
    }
    else
    {
        local player = null
        if (player = Entities.FindByClassname(player, "player"))
        {
            
            PreparePlayerAll()
            ScreenFade(null, 0, 0, 0, 255, 0.5, 5.0, 1)
            EntFireByHandle(self, "RunScriptCode", "PrepareCrates()", 1.0, null, null)

            BR_ISENABLED = true
        }
    }

    printl("You are playing on version " + SCRIPT_VERSION + " of Squad Showdown")
}

function StartBattleRoyale()
{
    BR_DELETEWEAPONS = true
    FillWeaponLists()

    //local classesArray = [7, 7, 7, 7, 7, 7, 7, 7]
    Convars.SetValue("tf_avoidteammates", 0)
    EntFire("rules", "SetRedTeamRespawnWaveTime", "9999", 0.0, null)
    EntFire("rules", "SetBlueTeamRespawnWaveTime", "9999", 0.0, null)

    local classesArray = [1, 2, 3, 4, 6, 7, 8, 9]

    local gamerules = Entities.FindByClassname(null, "tf_gamerules")
    NetProps.SetPropInt(gamerules, "m_iRoundState", 7)

    local roundtimer = Entities.FindByClassname(null, "team_round_timer")
    EntFireByHandle(roundtimer, "SetMaxTime", (BATTLEROYALE_CONFIG.BR_DOME_STAGE_TIME).tostring(), 0.0, null, null)
    EntFireByHandle(roundtimer, "SetTime", (BATTLEROYALE_CONFIG.BR_DOME_STAGE_TIME).tostring(), 0.0, null, null)

    ForceEnableUpgrades(2)
    /*Convars.SetValue("mp_friendlyfire", 1)
    Convars.SetValue("mp_autobalance", 0)
    Convars.SetValue("tf_avoidteammates", 0)
    Convars.SetValue("mp_teams_unbalance_limit", 0)
    Convars.SetValue("tf_scout_air_dash_count", 0)
    Convars.SetValue("tf_weapon_criticals", 0)
    EntFire("rules", "SetRedTeamRespawnWaveTime", "9999", 0.0, null)
    EntFire("rules", "SetBlueTeamRespawnWaveTime", "9999", 0.0, null)*/

    local mvm_resource = Entities.FindByClassname(null, "tf_objective_resource")
    NetProps.SetPropBool(mvm_resource, "m_bMannVsMachineBetweenWaves", false)
    NetProps.SetPropInt(mvm_resource, "m_nMannVsMachineWaveCount", 3)
    NetProps.SetPropInt(mvm_resource, "m_nMannVsMachineMaxWaveCount", 5)

    //Determine how squads will be split
    local playerCount = GetActivePlayerCount()
    local PossibleMaxSize = ceil(playerCount.tofloat() / classesArray.len().tofloat()) + 1
    local MaxSquadSize = 0
    local teamCount = 0
    for (local i = 1 ; i <= PossibleMaxSize ; i++)
    {
        if (playerCount % i == 0 && playerCount / i <= classesArray.len())
        {
            teamCount = playerCount / i
            MaxSquadSize = i
            break
        }
    }
    //Impossible to find the perfect squad size? Time to compromise (give a team 1 extra player?)
    if (MaxSquadSize == 0)
    {
        for (local i = 1 ; i <= PossibleMaxSize ; i++)
        {
            if (playerCount / i < classesArray.len())
            {
                teamCount = playerCount / i
                MaxSquadSize = i + 1
                break
            }
        }
    }
    //How many squads?
    BR_SQUADSARRAY <- array(teamCount)

    //Create spawnpoints
    local spawnPoints = array(teamCount)
    switch(teamCount)
    {
        case 1:
        spawnPoints = [1]
        break
        case 2:
        spawnPoints = [1, 9]
        break
        case 3:
        spawnPoints = [1, 6, 12]
        break
        case 4:
        spawnPoints = [1, 5, 9, 13]
        break
        case 5:
        spawnPoints = [1, 4, 7, 10, 14]
        break
        case 6:
        spawnPoints = [1, 4, 6, 9, 11, 14]
        break
        case 7:
        spawnPoints = [1, 3, 5, 8, 10, 12, 14]
        break
        case 8:
        spawnPoints = [1, 3, 5, 7, 9, 11, 13, 15]
        break

    }
    //Random offset
    local offset = RandomInt(0, 15)
    spawnPoints.apply(function(value) {
    if (value + offset > 16)
        return value + offset - 16
    else
        return value + offset;
    });

    //Create the squads
    for (local i = 0 ; i < teamCount ; i++)
    {
        local rnd = RandomInt(0, classesArray.len()-1)
        local playerClass = classesArray.remove(rnd)
        local brs = BattleRoyaleSquad(MaxSquadSize, playerClass)
        BR_SQUADSARRAY[i] = brs

        //Select Spawnpoint
        local id = spawnPoints[i]
        brs.spawnId = id
    }

    local play = null
    local squadsBuffer = []
    //Distribute the players to the squads
    while (play = Entities.FindByClassname(play, "player") )
    {
        if (IsValidPlayer(play) == false)
            continue

        //Fill the buffer with the squads array if empty
        if (squadsBuffer.len() == 0)
        {
            squadsBuffer = BR_SQUADSARRAY.slice()
        }
        //Pick random squad from the array then remove it
        local rnd = RandomInt(0, squadsBuffer.len()-1)
        local squad = squadsBuffer.remove(rnd)

        NetProps.SetPropBool(play, "m_bIsCoaching", true)
        NetProps.SetPropInt(play, "m_Shared.m_iDesiredPlayerClass", squad.playerClass)
        NetProps.SetPropInt(play, "m_Shared.m_iClass", squad.playerClass)
        //if (NetProps.GetPropInt(play, "m_iTeamNum") == 3)
            //NetProps.SetPropInt(play, "m_iTeamNum", 2)

        //NetProps.SetPropBool(play, "m_bIsCoaching", false)
        //play.ForceChangeTeam(2, false)
        squad.addPlayer(play)
        play.SetPlayerClass(squad.playerClass)
        //play.ForceRegenerateAndRespawn()
        //PreparePlayer(play)
        play.SetCurrency(BATTLEROYALE_CONFIG.STARTING_CASH)
        //Add important information to the player scope
        play.ValidateScriptScope()
        local scope = play.GetScriptScope()
        scope.squad <- squad
        scope.isAlive <- true
        scope.lastInspect <- 0
        scope.timeOutsideDome <- 0.0
        scope.healCooldown <- 10.0
        scope.pingBuffer <- 1.0
        scope.pingCooldown <- 5.0
        scope.pingCount <- 3
        scope.holdingTime <- 0.0
        scope.weapon_primary <- null
        scope.weapon_secondary <- null
        scope.weapon_melee <- null
        scope.interactibleTrigger <- null
        scope.ammo1 <- null
        scope.ammo2 <- null
        scope.clip1 <- null
        scope.clip2 <- null
        scope.health_fix <- null
        scope.killStreak <- 0
        scope.medkit_model <- null
        scope.damageReceivedForAssist <- array(MaxClients().tointeger(), 3000)
        scope.game_text <- SpawnEntityFromTable("game_text",
        {
            spawnflags   = 0
            message      = ""
            color        = "255 255 255"
            holdtime     = 0.5
            fxtime       = 0.25
            effect       = 0
            fadein       = 0.0
            fadeout      = 0.25
            channel      = 0
            x            = -1
            y            = 0.1
        })
        scope.cooldown_text <- SpawnEntityFromTable("game_text",
        {
            spawnflags   = 0
            message      = "▱▱▱▱▱▱"
            color        = "255 255 255"
            holdtime     = 0.5
            fxtime       = 0.25
            effect       = 0
            fadein       = 0.0
            fadeout      = 0.25
            channel      = 5
            x            = 0.92
            y            = 0.85
        })
        scope.game_text.ValidateScriptScope()
        scope.game_text.GetScriptScope().parent <- play  

        AddThinkToEnt(scope.game_text, "PlayerInteractionsThinker")

        scope.channel_game_text_delay <- play.entindex().tofloat()/100
        scope.channel_game_text_lastime <- 0.0
        scope.channel_cooldown_text_delay <- play.entindex().tofloat()/100 + 0.01
        scope.channel_cooldown_text_lastime <- 0.0
    }

    //Display information to players and give compensation money
    while (play = Entities.FindByClassname(play, "player") )
    {
        if (IsValidPlayer(play) == false)
            continue

        DisplayStartInformation(play)

        local SquadSize = play.GetScriptScope().squad.playerArray.len()
        if (SquadSize < MaxSquadSize)
        {
            play.AddCurrency(BATTLEROYALE_CONFIG.COMPENSATION_CASH)
            local text1 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + "You have been compensated "
            local text2 = "\x07" + format("%02X%02X%02X", 122, 140, 92) + BATTLEROYALE_CONFIG.COMPENSATION_CASH + "$ "
            local text3 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + "for having one less teammate."

            ClientPrint(play, 3, text1 + text2 + text3)
        }
    }

    BR_SQUADSALIVE <- BR_SQUADSARRAY
}

::BattleRoyaleSquad <- class
{
    id = null
    spawnId = null
    lastSpawnEnt = null
    name = "Epic Heavy Update"
    MaxSquadSize = 1
    playerArray = null
    playerClass = 3
    deathOrderArray = null
    revives = 0

    constructor(playerSize, squadClass)
	{
		MaxSquadSize = playerSize
		playerClass = squadClass

        switch (squadClass)
        {
            case 1:
            name = "Scout gang"
            break
            case 2:
            name = "Sniper gang"
            break
            case 3:
            name = "Soldier gang"
            break
            case 4:
            name = "Demoman gang"
            break
            case 5:
            name = "Medic gang"
            break
            case 6:
            name = "Heavy gang"
            break
            case 7:
            name = "Pyro gang"
            break
            case 8:
            name = "Spy gang"
            break
            case 9:
            name = "Engineer gang"
            break
        }

        playerArray = array(0)
        playerArray.clear()
        deathOrderArray = array(0)
        deathOrderArray.clear()

        revives = 0
	}

    function addPlayer(player)
    {
        playerArray.append(player)
    }

    function GetRevivePrice()
    {
        local revive_price = (revives * BATTLEROYALE_CONFIG.REVIVE_PRICE_INCREMENT) + BATTLEROYALE_CONFIG.REVIVE_PRICE
        if (revive_price > BATTLEROYALE_CONFIG.REVIVE_MAX_PRICE)
            revive_price = BATTLEROYALE_CONFIG.REVIVE_MAX_PRICE

        return revive_price
    }

    function isPlayerInSquad(player)
    {
        foreach (play in playerArray)
        {
        if (play == player)
            return true
        }
        return false
    }

    function isSquadAlive()
    {
        foreach (player in playerArray)
        {
            if (player != null && IsAlivePlayer(player))
            {
                if (player.GetScriptScope().isAlive)
                {
                    return true
                }
            }
        }
        return false
    }

    function IsThereDeadSquadmate()
    {
        foreach (player in deathOrderArray)
        {
            if (player == null || player.IsValid() == false)
                continue

            if (player.GetScriptScope().isAlive != false)
                continue

            return true
        }
        return false
    }

    function SquadAliveCount()
    {
        local count = 0
        foreach (player in playerArray)
        {
            if (player != null && player.IsValid())
            {
                if (player.GetScriptScope().isAlive)
                {
                    count++
                }
            }
        }

        return count
    }

    function GetLastSurvivor()
    {
        foreach (player in playerArray)
        {
            if (player != null && player.IsValid())
            {
                if (player.GetScriptScope().isAlive)
                {
                    return player
                }
            }
        }
        return null
    }

    function TriggerDeathResponse()
    {
        local alivePlayers = []
        foreach (player in playerArray)
        {
            if (player != null && player.IsValid())
            {
                if (player.GetScriptScope().isAlive)
                {
                    alivePlayers.append(player)
                }
            }
        }
        if (alivePlayers.len() <= 0)
            return

        local soundscript = TFCLASS_DISPLAYNAME[this.playerClass] + "_mvm_class_is_dead0" + this.playerClass
        local player = alivePlayers[RandomInt(0, alivePlayers.len()-1)]
        //1 person says his teammate is dead
        EntFireByHandle(player, "AddContext", "IsMvMDefender:1", 0.0, null, null)
        EntFireByHandle(player, "AddContext", "randomnum:100", 0.0, null, null)
        EntFireByHandle(player, "AddContext", "victimclass:" +  TFCLASS_DISPLAYNAME[this.playerClass], 0.0, null, null)
        EntFireByHandle(player, "SpeakResponseConcept", "TLK_MVM_DEFENDER_DIED", 0.0, null, null) 
    }
}

function FindPlayerSquad(player)
{
    for (local i = 0; i < BR_SQUADSARRAY.len(); i++)
    {
        if (BR_SQUADSARRAY[i].isPlayerInSquad(player))
        {
            return BR_SQUADSARRAY[i]
        }
    }
}

function PreparePlayerAll()
{
    BR_REFUND_PHASE = true

    Gamemode_teams() 

    BR_REFUND_PHASE = false

}

function PreparePlayerRevived()
{
    local player = activator

    SetBRSpeed(player)
    SetBRHealth(player)

    if (player.GetPlayerClass() == 6)
        player.AddCustomAttribute("damage force increase hidden", 2, -1)

    player.AddCustomAttribute("no double jump", 1, -1)

    local scope = activator.GetScriptScope()
    local weaponPrimary = scope.weapon_primary
    local weaponSecondary = scope.weapon_secondary
    local weaponMelee = scope.weapon_melee

    if (weaponPrimary)
    {
        local gun = activator.GiveBRWeapon(weaponPrimary)
        /*for (local i = 0; i < weaponPrimary.attributeIndexes.len(); i++)
        {
            gun.AddAttribute(weaponPrimary.attributeIndexes[i].tf_attribute, weaponPrimary.attributeIndexes[i].start_value + (weaponPrimary.attributeValues[i] * weaponPrimary.attributeIndexes[i].increment), -1)
        }*/
    }
    else
    {
        local gun = activator.GiveWeapon(13)
        gun.AddAttribute("damage bonus HIDDEN", 1.3, -1)
    }

    if (weaponSecondary)
    {
        local gun = activator.GiveBRWeapon(weaponSecondary)
        /*for (local i = 0; i < weaponSecondary.attributeIndexes.len(); i++)
        {
            gun.AddAttribute(weaponSecondary.attributeIndexes[i].tf_attribute, weaponSecondary.attributeIndexes[i].start_value + (weaponSecondary.attributeValues[i] * weaponSecondary.attributeIndexes[i].increment), -1)
        }*/
    }
    else
    {
        local gun = activator.GiveWeapon(16)
        gun.AddAttribute("damage bonus HIDDEN", 1.6, -1)
    }
    if (weaponMelee)
    {
        local gun = activator.GiveBRWeapon(weaponMelee)
        /*for (local i = 0; i < weaponMelee.attributeIndexes.len(); i++)
        {
            gun.AddAttribute(weaponMelee.attributeIndexes[i].tf_attribute, weaponMelee.attributeIndexes[i].start_value + (weaponMelee.attributeValues[i] * weaponMelee.attributeIndexes[i].increment), -1)
        }*/
    }
    else
    {
        GiveDefaultMelee(activator)
    }
    scope.healCooldown = 6.0

}

function PreparePlayerEarlyDeath()
{
    local playerscope = activator.GetScriptScope()
    NetProps.SetPropInt(activator, "m_Shared.m_iDesiredPlayerClass", playerscope.squad.playerClass)
    NetProps.SetPropInt(activator, "m_Shared.m_iClass", playerscope.squad.playerClass)
    activator.SetPlayerClass(playerscope.squad.playerClass)
    PreparePlayer(activator)
    EntFireByHandle(self, "RunScriptCode", "GiveDefaultMeleeFix()", 0.0, activator, activator)
}

function PreparePlayer(player)
{
    SetBRSpeed(player)
    SetBRHealth(player)

    if (player.GetPlayerClass() == 6)
        player.AddCustomAttribute("damage force increase hidden", 2, -1)

    player.AddCustomAttribute("no double jump", 1, -1)

    player.ValidateScriptScope()

    /*local HideHudValue = NetProps.GetPropInt(player, "m_Local.m_iHideHUD")
    NetProps.SetPropInt(player, "m_Local.m_iHideHUD", HideHudValue | (
                                                  Constants.FHideHUD.HIDEHUD_BONUS_PROGRESS)
                                                ) */// adds bits

    //player.GTFW_Cleanup()	//clean up function, deletes unused weapon entities from GiveWeapon.
    EntFireByHandle(self, "RunScriptCode", "GiveDefaultMeleeFix()", 1.0, player, player)

    //EntFireByHandle(self, "RunScriptCode", "EquipMedkitModel()", 1.0, player, player)
    //player.SetScriptOverlayMaterial("")
}

function EquipMedkitModel()
{
    if (!IsAlivePlayer(activator) || !("medkit_model" in activator.GetScriptScope()))
        return

    local player = activator
    //EntFireByHandle(player.GetScriptScope().medkit_model, "Kill", "",0.0, player, player)
    //Give the Medkit
    local propDynamic = SpawnEntityFromTable("tf_wearable", 
    {
        // This is a table of keyvalues, which is the same way as keyvalues that are defined in Hammer
        // Key         Value
        targetname = "tf_wearable_player_medkit_322",
        model = "models/battleroyale/player_medkit.mdl",
        solid       = 0,
        disableshadows = 1,
        disablereceiveshadows = 1,
        fademaxdist = 4000,
        fademindist = 3500,
        rendermode = 10
    })
    player.GetScriptScope().medkit_model = propDynamic
    
    NetProps.SetPropBool(propDynamic, "m_bForcePurgeFixedupStrings", true);
    NetProps.SetPropInt(propDynamic, "m_nModelIndex", 1);
    NetProps.SetPropBool(propDynamic, "m_bValidatedAttachedEntity", true);
    NetProps.SetPropBool(propDynamic, "m_AttributeManager.m_Item.m_bInitialized", true);
    NetProps.SetPropEntity(propDynamic, "m_hOwnerEntity", player);

    propDynamic.SetOwner(player);

    propDynamic.SetModel("models/battleroyale/player_medkit.mdl");

    NetProps.SetPropInt(propDynamic, "m_fEffects", Constants.FEntityEffects.EF_BONEMERGE_FASTCULL);

    EntFireByHandle(propDynamic, "SetParent", "!activator", 0.5, player, player)
    EntFireByHandle(propDynamic, "SetParentAttachment", "flag", 0.5, player, player)
    //EntFireByHandle(propDynamic, "AddOutPut", "classname prop_dynamic", -1, player, player)
}

function GiveDefaultMeleeFix()
{
    GiveDefaultMelee(activator)
}

::SetBRHealth <- function(player)
{
    local HealthTarget = BATTLEROYALE_CONFIG.PLAYER_HEALTH
    local ClassHealth = 125

    switch (player.GetPlayerClass())
    {
        case 1: //scout
            ClassHealth = 125
            break
        case 2: //sniper
            ClassHealth = 125
            break
        case 3: //soldier
            ClassHealth = 200
            break
        case 4: //demoman
            ClassHealth = 175
            break
        case 5: //medic
            ClassHealth = 150
            break
        case 6: //heavy
            ClassHealth = 300
            break
        case 7: //pyro
            ClassHealth = 175
            break
        case 8: //spy
            ClassHealth = 125
            break
        case 9: //engineer
            ClassHealth = 125
            break
    }
    player.SetHealth(HealthTarget)
    player.SetMaxHealth(HealthTarget)
    player.AddCustomAttribute("max health additive penalty", HealthTarget - ClassHealth, -1)
}

::SetBRSpeed <- function(player)
{
    local SpeedTarget = BATTLEROYALE_CONFIG.PLAYER_SPEED
    local ClassSpeed = 300.0

    switch (player.GetPlayerClass())
    {
        case 1: //scout
            ClassSpeed = 400.0
            break
        case 2: //sniper
            ClassSpeed = 300.0
            break
        case 3: //soldier
            ClassSpeed = 240.0
            break
        case 4: //demoman
            ClassSpeed = 280.0
            break
        case 5: //medic
            ClassSpeed = 320.0
            break
        case 6: //heavy
            ClassSpeed = 230.0
            break
        case 7: //pyro
            ClassSpeed = 300.0
            break
        case 8: //spy
            ClassSpeed = 320.0
            break
        case 9: //engineer
            ClassSpeed = 300.0
            break
    }

    local result = SpeedTarget/ClassSpeed

    player.AddCustomAttribute("move speed penalty", result, -1)
}

::CheckRoundStatus <- function()
{
    
    if ((BR_ISENABLED == false && EarlyDeathRespawn == true) || BR_END_PHASE == true)
    {
        return
    }

    local text1 = null
    local text2 = null
    local text3 = null
    //NetProps.SetPropInt(play, "m_Shared.m_lifeState", squad.playerClass)
    foreach (squad in BR_SQUADSALIVE)
    {
        if (squad.isSquadAlive() == false)
        {
            BR_SQUADSALIVE.remove(BR_SQUADSALIVE.find(squad))
            text1 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + "The squad "
            text2 = "\x07" + format("%02X%02X%02X", 186, 52, 53) + squad.name
            text3 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + " Has been wiped out!"

            ClientPrint(null, 3, text1 + text2 + text3)

            text1 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + "There are "
            text2 = "\x07" + format("%02X%02X%02X", 186, 52, 53) + BR_SQUADSALIVE.len()
            text3 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + " teams remaining."

            ClientPrint(null, 3, text1 + text2 + text3)

            local soundTable =
            {
                sound_name = "misc\\halloween\\strongman_bell_01.wav"
            }

            EmitSoundEx(soundTable)
        }
    }
    //Winner!
    if (BR_SQUADSALIVE.len() == 1)
    {
        text1 = "\x07" + format("%02X%02X%02X", 186, 52, 53) + BR_SQUADSARRAY[0].name
        text2 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + " is the last squad standing!"
        ClientPrint(null, 3, text1 + text2)

        text1 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + "The winners are:"
        text2 = ""
        foreach (squadmate in BR_SQUADSARRAY[0].playerArray)
        {
            if (IsValidPlayer(squadmate) == false)
                continue

            text2 += "\x07" + format("%02X%02X%02X", 186, 52, 53) + " " + NetProps.GetPropString(squadmate, "m_szNetname")
            text2 += "\x07" + format("%02X%02X%02X", 255, 255, 255) + ","
        }
        text2 = text2.slice(0, text2.len()-7)
        ClientPrint(null, 3, text1 + text2)

        EntFire("roundwin", "RoundWin", "", 0.0, null)
        Dome_Disable()
        BR_END_PHASE = true
        ForceEnableUpgrades(0)
    }
    if (BR_SQUADSALIVE.len() == 0)
    {
        text1 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + "No one wins!"
        ClientPrint(null, 3, text1)
        EntFire("roundwin", "RoundWin", "", 0.0, null)
        Dome_Disable()
        BR_END_PHASE = true
        ForceEnableUpgrades(0)
    }
    /*local hPlayer = null
    while (hPlayer = Entities.FindByClassname(hPlayer, "player") )
    {
        hPlayer.GTFW_Cleanup()
    }*/
}

function DisplayStartInformation(player)
{
    local text1 = null
    local text2 = null
    local text3 = null
    local scope = player.GetScriptScope()

    text1 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + "Your squad is "
    text2 = "\x07" + format("%02X%02X%02X", 186, 52, 53) + player.GetScriptScope().squad.name

    ClientPrint(player, 3, text1 + text2)

    //Display squadmates unless alone
    if (scope.squad.playerArray.len() > 1)
    {

        text1 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + "Your squadmates are:"
        text2 = ""
        foreach (squadmate in scope.squad.playerArray)
        {
            if (IsValidPlayer(squadmate) == false)
                continue

            if (squadmate != player)
            {
                text2 += "\x07" + format("%02X%02X%02X", 186, 52, 53) + " " + NetProps.GetPropString(squadmate, "m_szNetname")
                text2 += "\x07" + format("%02X%02X%02X", 255, 255, 255) + ","
            }
        }
        text2 = text2.slice(0, text2.len()-7)

        ClientPrint(player, 3, text1 + text2)
    }

    text1 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + "Eliminate the other classes to win. "

    ClientPrint(player, 3, text1)

    ClientPrint(player, Constants.EHudNotify.HUD_PRINTCENTER, "You have been assigned to the " + GetPlayerClassName(player) + " squad\nKill anyone who is not " + GetPlayerClassName(player))
}

function PrecacheEverything()
{
    self.PrecacheSoundScript("weapons\\teleporter_receive.wav")
    self.PrecacheSoundScript("misc\\halloween\\strongman_bell_01.wav")
    self.PrecacheSoundScript("HealthKit.Touch")
    self.PrecacheSoundScript("Announcer.AM_LastManAlive01")
    self.PrecacheSoundScript("Announcer.AM_LastManAlive02")
    self.PrecacheSoundScript("Announcer.AM_LastManAlive03")
    self.PrecacheSoundScript("Announcer.AM_LastManAlive04")
    self.PrecacheSoundScript(BATTLEROYALE_CONFIG.SOUND_CASH_COLLECTED)
    self.PrecacheSoundScript("ui.cratesmash_common")
    self.PrecacheSoundScript("Powerup.PickUpStrength")
    self.PrecacheSoundScript("Powerup.PickUpResistance")
    self.PrecacheSoundScript("Powerup.PickUpRegeneration")
    self.PrecacheSoundScript("Powerup.PickUpHaste")
    self.PrecacheSoundScript("Powerup.PickUpVampire")
    self.PrecacheSoundScript("Powerup.PickUpPrecision")
    self.PrecacheSoundScript("Powerup.PickUpAgility")
    self.PrecacheSoundScript("Powerup.PickUpKnockout")
    self.PrecacheSoundScript("Powerup.PickUpKing")
    self.PrecacheSoundScript("Powerup.PickUpPlague")
    self.PrecacheSoundScript("Powerup.PickUpSupernova")
    self.PrecacheModel(BATTLEROYALE_CONFIG.MODEL_CASH_SMALL)
    self.PrecacheModel(BATTLEROYALE_CONFIG.MODEL_CASH_MEDIUM)
    self.PrecacheModel(BATTLEROYALE_CONFIG.MODEL_CASH_BIG)
    self.PrecacheModel("models\\kirillian\\brsphere_huge.mdl")
    self.PrecacheModel("models\\kirillian\\brsphere_huge_v3.mdl")
}

function SetCenterPoint()
{
    local target = Entities.FindByName(null, "br_center_point")
    if (target != null)
    {
        local origin = target.GetOrigin()
        BATTLEROYALE_CONFIG.BR_CENTER_POINT[0] = origin.x
        BATTLEROYALE_CONFIG.BR_CENTER_POINT[1] = origin.y
        BATTLEROYALE_CONFIG.BR_CENTER_POINT[2] = origin.z
    }
}

function GetPlayerClassName(player)
{
        switch (player.GetPlayerClass())
        {
        case 1: //scout
            return "Scout"
            break
        case 2: //sniper
            return "Sniper"
            break
        case 3: //soldier
            return "Soldier"
            break
        case 4: //demoman
            return "Demoman"
            break
        case 5: //medic
            return "Medic"
            break
        case 6: //heavy
            return "Heavy"
            break
        case 7: //pyro
            return "Pyro"
            break
        case 8: //spy
            return "Spy"
            break
        case 9: //engineer
            return "Engineer"
            break
    }
}

function PrepareCrates()
{
    local crate = null

    while (crate = Entities.FindByClassname(crate, "prop_dynamic") )
    {
        if (NetProps.GetPropString(crate, "m_iszVScripts") == "battleroyale/battleroyale_crate.nut")
            crate.GetScriptScope().InitializeCrate()
    }
    crate = null
    while (crate = Entities.FindByClassname(crate, "prop_dynamic_override") )
    {
        if (NetProps.GetPropString(crate, "m_iszVScripts") == "battleroyale/battleroyale_crate.nut")
            crate.GetScriptScope().InitializeCrate()
    }
    crate = null
    while (crate = Entities.FindByClassname(crate, "prop_physics") )
    {
        if (NetProps.GetPropString(crate, "m_iszVScripts") == "battleroyale/battleroyale_crate.nut")
            crate.GetScriptScope().InitializeCrate()
    }
    crate = null
    while (crate = Entities.FindByClassname(crate, "prop_physics_override") )
    {
        if (NetProps.GetPropString(crate, "m_iszVScripts") == "battleroyale/battleroyale_crate.nut")
            crate.GetScriptScope().InitializeCrate()
    }
}

function IntroductionMessage(message_number)
{
    local message = ""

    switch(message_number)
    {
        case 0:
        message = "Welcome to Team Fortress BattleRoyale!"
        break
        case 1:
        message = "The objective of the game is to eliminate the other classes."
        break
        case 2:
        message = "You will soon be assigned a class\nPlayers of your same class will be your teammates."
        break
        case 3:
        message = "Crates are scattered around the map\nOpen them to find weapons using the Action Button or M3."
        break
        case 4:
        message = "Hold Inspect to check your current weapon's stats and find the closest ally.\nIt will also display your current money."
        break
        case 5:
        message = "You can heal your teammates by pressing the Action Button or M3 on them.\nThis has a "+ format("%.0f", BATTLEROYALE_CONFIG.HEALING_COOLDOWN)+"s cooldown."
        break
    }

    ClientPrint(null, Constants.EHudNotify.HUD_PRINTCENTER, message)
    ClientPrint(null, 3, message)
}

function GiveParachuteAll()
{
    local player = null
    while (player = Entities.FindByClassname(player, "player"))
    {
        player.AddCond(Constants.ETFCond.TF_COND_PARACHUTE_ACTIVE)
    }
}
