//This script is by Alex Turtle

maxweight <- 0

::TriggerAirdropEvent <- function()
{
    CalculateChances()

    local amount = (BR_CURRENT_DOME_STAGE * BATTLEROYALE_CONFIG.AIRDROP_COUNT_INCREMENT) + BATTLEROYALE_CONFIG.AIRDROP_COUNT_BASE

    local i = 0
    local length = DOME_CURRENT_RADIUS * 0.5
    while (amount > i)
    {
        local x = RandomFloat(dome.GetOrigin().x - length, dome.GetOrigin().x + length)
        local y = RandomFloat(dome.GetOrigin().y - length, dome.GetOrigin().y + length)
        local z = BATTLEROYALE_CONFIG.BR_CENTER_POINT[2] + BATTLEROYALE_CONFIG.AIRDROP_SPAWN_Z

        SpawnAirdrop(Vector(x, y, z), PickRandomAirdrop(), "airdrop_crate" + BR_CURRENT_DOME_STAGE + "n" + i)    
        i++
    }

}

function CalculateChances()
{
    maxweight = 0
    for (local i = 0; AIRDROP_POOL.len() > i; i++)
    {
        local buffer = AIRDROP_POOL[i].chance + (AIRDROP_POOL[i].chance_modifier * (BATTLEROYALE_CONFIG.BR_DOME_STAGES - BR_CURRENT_DOME_STAGE + 1))
        if (buffer <= 0)
            continue
        
        maxweight += buffer
    }
}

function PickRandomAirdrop()
{
    local i = 0
    local chance = 0
    local rnd = RandomInt(0, maxweight)
    for (local i = 0; AIRDROP_POOL.len() > i; i++)
    {
        local buffer = AIRDROP_POOL[i].chance + (AIRDROP_POOL[i].chance_modifier * (BATTLEROYALE_CONFIG.BR_DOME_STAGES - BR_CURRENT_DOME_STAGE + 1))
        if (buffer <= 0)
            continue

        chance += buffer

        if (rnd < chance)
        {
            return i
        }
    }
    return i
}

function SpawnAirdrop(location, cratetype, name)
{
    local airdrop = SpawnEntityFromTable("prop_dynamic", 
    {
        // This is a table of keyvalues, which is the same way as keyvalues that are defined in Hammer
        // Key         Value
        targetname = name
        model = "models/props_temple/crate_junglegear_closed.mdl",
        origin     = location,
        angles     = "0 " + RandomInt(0, 360) + " 0",
        vscripts   = "battleroyale/battleroyale_crate.nut",
        thinkfunction =  "AirdropThink",
        solid       = 2,
        disableshadows = 1,
        disablereceiveshadows = 1
    })
    //airdrop.GetScriptScope().price_modifier = pow(AIRDROP_POOL[cratetype].price_modifier, BATTLEROYALE_CONFIG.BR_DOME_STAGES - BR_CURRENT_DOME_STAGE)
    airdrop.GetScriptScope().SetCrate(AIRDROP_POOL[cratetype].name, false)

    airdrop.SetMoveType(Constants.EMoveType.MOVETYPE_FLYGRAVITY, Constants.EMoveCollide.MOVECOLLIDE_FLY_BOUNCE)
    airdrop.SetGravity(0.05)
}