//This script is by Alex Turtle
IncludeScript("battleroyale/battleroyale_airdrop.nut")

::BR_DOME_DESTINATION_MODEL <- "models/kirillian/brsphere_huge_v3.mdl"
::BR_DOME_ACTUAL_MODEL <- "models/kirillian/brsphere_huge.mdl"

::BR_DOME_MODEL_RADIUS <- 10000.0 // Radius of the model in hu
::BR_DOME_THINK_DELAY <- 0.1 // You're not supposed to touch that
::BR_CURRENT_DOME_STAGE <- 0 // You're not supposed to touch that
::DomeTime <- null // You're not supposed to touch that
::dome <- null // You're not supposed to touch that
::destinationDome <- null // You're not supposed to touch that

::DOME_CURRENT_RADIUS <- 10000.0 // You're not supposed to touch that
::br_dome_enabled <- false // You're not supposed to touch that

function SetupDome()
{
    local scale = BATTLEROYALE_CONFIG.BR_STARTING_RADIUS / BR_DOME_MODEL_RADIUS
    dome = SpawnEntityFromTable("prop_dynamic", 
    {
    // This is a table of keyvalues, which is the same way as keyvalues that are defined in Hammer
    // Key         Value
    model = BR_DOME_ACTUAL_MODEL,
    modelscale = sqrt(scale),
    rendercolor       = BATTLEROYALE_CONFIG.BR_DOME_COLOR,
    origin     = Vector(BATTLEROYALE_CONFIG.BR_CENTER_POINT[0], BATTLEROYALE_CONFIG.BR_CENTER_POINT[1], BATTLEROYALE_CONFIG.BR_CENTER_POINT[2]),
    renderamt   = 150,
    rendermode  = 1,
    disableshadows = 1,
    disablereceiveshadows = 1,
    StartDisabled = 1,
    solid = 0,
    })
    dome.AddEFlags(Constants.FEntityEFlags.EFL_IN_SKYBOX)
    DomeTransitionTime <- BATTLEROYALE_CONFIG.BR_DOME_FIRST_TRANSITION_TIME
    DomeTime <- GetDomeDynamicTime(BATTLEROYALE_CONFIG.BR_DOME_FIRST_STAGE_TIME, BATTLEROYALE_CONFIG.BR_DOME_FIRST_TRANSITION_TIME)
    DomeTotalTime <- GetDomeDynamicTime(BATTLEROYALE_CONFIG.BR_DOME_FIRST_STAGE_TIME, BATTLEROYALE_CONFIG.BR_DOME_FIRST_TRANSITION_TIME) + BATTLEROYALE_CONFIG.BR_DOME_FIRST_TRANSITION_TIME
    BR_CURRENT_DOME_STAGE <- BATTLEROYALE_CONFIG.BR_DOME_STAGES
    lerpValue <- 9999.99
    WarningAvailable <- true

    roundtimer <- Entities.FindByClassname(null, "team_round_timer")

    UpdateRoundTimer()

    PickRandomPoint()
}

function DomeThink()
{
    if (!br_dome_enabled)
        return BR_DOME_THINK_DELAY

    DomeTime <- DomeTime - BR_DOME_THINK_DELAY
    DomeTotalTime <- DomeTotalTime - BR_DOME_THINK_DELAY
    //Warn the dome is about to close
    if (DomeTime < 15.0 && WarningAvailable)
    {
        local text1 = null
        local text2 = null
        local text3 = null

        text1 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + "15 seconds before "
        text2 = "\x07" + format("%02X%02X%02X", 186, 52, 53) + "The Dome"
        text3 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + " shrinks!"

        ClientPrint(null, 3, text1 + text2 + text3)

        WarningAvailable <- false
    }
    //The dome is moving onto the next phase!
    if (DomeTime < 0.0)
    {

        if (BR_CURRENT_DOME_STAGE > 1)
            BR_CURRENT_DOME_STAGE = BR_CURRENT_DOME_STAGE - 1
        else
            BR_CURRENT_DOME_STAGE = BR_CURRENT_DOME_STAGE.tofloat() / 2.0

        //Hard cap
        if (BR_CURRENT_DOME_STAGE < 0.1)
            BR_CURRENT_DOME_STAGE = 0.0

        scale <- ((1.0 / BATTLEROYALE_CONFIG.BR_DOME_STAGES) * BR_CURRENT_DOME_STAGE) * (BATTLEROYALE_CONFIG.BR_STARTING_RADIUS / BR_DOME_MODEL_RADIUS)

        //Final phases
        if (BR_CURRENT_DOME_STAGE < 1)
        {
            DomeTime = BATTLEROYALE_CONFIG.BR_DOME_FINAL_STAGE_TIME
            DomeTransitionTime = BATTLEROYALE_CONFIG.BR_DOME_FINAL_TRANSITION_TIME
        }
        else
        {
            //second stage
            if (BR_CURRENT_DOME_STAGE == BATTLEROYALE_CONFIG.BR_DOME_STAGES - 1)
                DomeTime = GetDomeDynamicTime(BATTLEROYALE_CONFIG.BR_DOME_FIRST_STAGE_TIME, BATTLEROYALE_CONFIG.BR_DOME_FIRST_TRANSITION_TIME)
            else
                DomeTime = GetDomeDynamicTime(BATTLEROYALE_CONFIG.BR_DOME_STAGE_TIME, BATTLEROYALE_CONFIG.BR_DOME_TRANSITION_TIME)
        }

        //dome.SetModelScale(sqrt(scale), DomeTransitionTime)
        domeScale <- dome.GetModelScale()
        lerpValue <- 0.0

        local text1 = null
        local text2 = null

        text1 = "\x07" + format("%02X%02X%02X", 186, 52, 53) + "The Dome"
        text2 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + " is shrinking!"

        ClientPrint(null, 3, text1 + text2)

        WarningAvailable <- true

        //Set new Timer
        UpdateRoundTimer()
    }
    //The dome has closed, choose another point in space for the next dome
    if (DomeTotalTime < 0.0 && lerpValue > DomeTransitionTime)
    {
        destinationDome.Kill()
        DomeTotalTime <- DomeTime
        PickRandomPoint()

        if (BR_CURRENT_DOME_STAGE >= 1.0)
            TriggerAirdropEvent()
    }
    //LERP the dome so it smoothly transitions to its destination
    if (lerpValue < DomeTransitionTime)
    {
        lerpValue <- lerpValue + BR_DOME_THINK_DELAY
        local k = lerpValue / DomeTransitionTime

        //Math fix for the dome shrinking too fast
        k = k * k

        //scale
        dome.SetModelScale(lerp(domeScale, sqrt(scale), k), BR_DOME_THINK_DELAY)


        //location
        local x = lerp(dome.GetOrigin().x, destinationDome.GetOrigin().x, k)
        local y = lerp(dome.GetOrigin().y, destinationDome.GetOrigin().y, k)
        local z = lerp(dome.GetOrigin().z, destinationDome.GetOrigin().z, k)
        dome.SetAbsOrigin(Vector(x,y,z))
    }
    
    HurtPlayersOutsideThink()
    return BR_DOME_THINK_DELAY
}

function PickRandomPoint()
{
    local overtime = false
    local stage = 1

    if (BR_CURRENT_DOME_STAGE > 1)
    {
        stage = BR_CURRENT_DOME_STAGE - 1
    }
    else
    {
        overtime = true
        stage = BR_CURRENT_DOME_STAGE.tofloat() / 2.0
    }

    DOME_CURRENT_RADIUS = BR_DOME_MODEL_RADIUS * dome.GetModelScale() * dome.GetModelScale()

    local ratio = 1.0 / BATTLEROYALE_CONFIG.BR_DOME_STAGES

    local length = DOME_CURRENT_RADIUS * ratio

    if (overtime)
        length *= 2.5
    else
        length *= 1.0//(1 + ratio)

    //force the dome to be in the exact middle for 2 stages
    local x = dome.GetOrigin().x
    local y = dome.GetOrigin().y
    local z = dome.GetOrigin().z

    if (BATTLEROYALE_CONFIG.BR_DOME_STAGES - BR_CURRENT_DOME_STAGE > 1)
    {
        x = RandomFloat(dome.GetOrigin().x - length, dome.GetOrigin().x + length)
        y = RandomFloat(dome.GetOrigin().y - length, dome.GetOrigin().y + length)
        //z = dome.GetOrigin().z
        if (!overtime)
            z = RandomFloat(BATTLEROYALE_CONFIG.BR_CENTER_POINT[2] + BATTLEROYALE_CONFIG.BR_DOME_MIN_Z,BATTLEROYALE_CONFIG.BR_CENTER_POINT[2] + BATTLEROYALE_CONFIG.BR_DOME_MAX_Z)
    }

    local scale = ((1.0 / BATTLEROYALE_CONFIG.BR_DOME_STAGES) * (stage)) * (BATTLEROYALE_CONFIG.BR_STARTING_RADIUS / BR_DOME_MODEL_RADIUS)
    local propDynamic = SpawnEntityFromTable("prop_dynamic", 
    {
    // This is a table of keyvalues, which is the same way as keyvalues that are defined in Hammer
    // Key         Value
    model = BR_DOME_DESTINATION_MODEL,
    modelscale = sqrt(scale),
    rendercolor = BATTLEROYALE_CONFIG.BR_DOME_DESTINATION_COLOR,
    renderamt   = 125,
    rendermode  = 1,
    origin     = Vector(x, y, z),
    disableshadows = 1,
    disablereceiveshadows = 1,
    StartDisabled = 1,
    solid = 0,
    })
    destinationDome = propDynamic
    destinationDome.AddEFlags(Constants.FEntityEFlags.EFL_IN_SKYBOX)
    
    if (br_dome_enabled)
        EntFireByHandle(destinationDome, "Enable", "", -1, null, null)
}

function HurtPlayersOutsideThink()
{
    if (dome == null)
    {
        return
    }

    local length = 0.0
    if (dome.GetModelScale() > 0.0)
    {
        length = BR_DOME_MODEL_RADIUS * dome.GetModelScale() * dome.GetModelScale()
    }
    local play = null
    local distance = null
    while (play = Entities.FindByClassname(play, "player") )
    {
        distance = distanceVectors(play.GetOrigin(), dome.GetOrigin())
        if (distance > length && IsAlivePlayer(play))
        {
            play.GetScriptScope().timeOutsideDome += BR_DOME_THINK_DELAY
            local damage = floor(play.GetScriptScope().timeOutsideDome).tofloat()
            //equalize damage taken by resist carriers
            if (play.InCond(Constants.ETFCond.TF_COND_RUNE_RESIST))
                damage *= 1.5

            play.TakeDamageCustom(dome, dome, null, Vector(), Vector(), damage, 2048, Constants.ETFDmgCustom.TF_DMG_CUSTOM_PLASMA)
            play.BleedPlayerEx(BR_DOME_THINK_DELAY, 0, false, 25)
        }
        else if ("timeOutsideDome" in play.GetScriptScope())
        {
            if (play.GetScriptScope().timeOutsideDome > 0.0)
                play.GetScriptScope().timeOutsideDome -= (BR_DOME_THINK_DELAY * 3.0)
            else
                play.GetScriptScope().timeOutsideDome = 0.0
        }
    }
}

function lerp(start, end, t) 
{
    return (1 - t) * start + t * end;
}

function distanceVectors(p1, p2) {
  local x = p2.x - p1.x;
  local y = p2.y - p1.y;
  local z = p2.z - p1.z;
  return sqrt(x*x + y*y + z*z);
}

function UpdateRoundTimer()
{
    EntFireByHandle(roundtimer, "SetMaxTime", (DomeTime).tostring(), 0.0, null, null)
    EntFireByHandle(roundtimer, "SetTime", (DomeTime).tostring(), 0.0, null, null)
}

function GetDomeDynamicTime(max_time, min_time)
{
    //use max when above 24 players, use min when 12 players, dynamic
    local count = GetAlivePlayerCount()
    if (count > BATTLEROYALE_CONFIG.IDEAL_PLAYER_COUNT)
        count = BATTLEROYALE_CONFIG.IDEAL_PLAYER_COUNT

    if (count < BATTLEROYALE_CONFIG.IDEAL_PLAYER_COUNT / 2.0)
        count = BATTLEROYALE_CONFIG.IDEAL_PLAYER_COUNT / 2.0

    local diff = max_time - min_time
    return min_time + ((count / (BATTLEROYALE_CONFIG.IDEAL_PLAYER_COUNT).tofloat()) * diff)
}

::Dome_Enable <- function()
{
    br_dome_enabled = true
    EntFireByHandle(dome, "Enable", "", -1, null, null)
    EntFireByHandle(destinationDome, "Enable", "", -1, null, null)
}

::Dome_Disable <- function()
{
    br_dome_enabled = false
    EntFireByHandle(dome, "Disable", "", -1, null, null)
    EntFireByHandle(destinationDome, "Disable", "", -1, null, null)
}