ClearGameEventCallbacks()

function OnGameEvent_player_spawn(params)
{
    if ("Vehicle_OnPlayerSpawn" in getroottable())
        Vehicle_OnPlayerSpawn(params);

	local player = GetPlayerFromUserID(params.userid)
    if (player == null)
		return;
	
	// players only join unassigned team once, so this is the best place to init
	/*if (params.team == 0) // TEAM_UNASSIGNED
	{
		return
	}*/

    local scope = player.GetScriptScope()
    player.RemoveCond(Constants.ETFCond.TF_COND_TEAM_GLOWS)
    player.AddCond(Constants.ETFCond.TF_COND_POWERUPMODE_DOMINANT)
    //scope.lastAttack <- 0.0
    //scope.awaitingReset <- false

    player.AddHudHideFlags(Constants.FHideHUD.HIDEHUD_BUILDING_STATUS |
    Constants.FHideHUD.HIDEHUD_PIPES_AND_CHARGE)

    if (NetProps.GetPropInt(player, "m_iTeamNum") == 3)
        player.ForceChangeTeam(2, true)

    //Give the Medkit
    EntFire("script_main", "RunScriptCode", "EquipMedkitModel()", 5.5, player)
    /*local propDynamic = SpawnEntityFromTable("tf_wearable", 
    {
        // This is a table of keyvalues, which is the same way as keyvalues that are defined in Hammer
        // Key         Value
        targetname = "tf_wearable_player_medkit_322",
        model = "models/battleroyale/player_medkit.mdl",
        solid       = 0,
        disableshadows = 1,
        disablereceiveshadows = 1,
        rendermode = 0
    })
    player.GetScriptScope().medkit_model = propDynamic
    
    NetProps.SetPropBool(propDynamic, "m_bForcePurgeFixedupStrings", true);
    NetProps.SetPropInt(propDynamic, "m_nModelIndex", 2);
    NetProps.SetPropBool(propDynamic, "m_bValidatedAttachedEntity", true);
    NetProps.SetPropBool(propDynamic, "m_AttributeManager.m_Item.m_bInitialized", true);
    NetProps.SetPropEntity(propDynamic, "m_hOwnerEntity", player);

    propDynamic.SetOwner(player);

    propDynamic.SetModel("models/battleroyale/player_medkit.mdl");

    NetProps.SetPropInt(propDynamic, "m_fEffects", Constants.FEntityEffects.EF_BONEMERGE_FASTCULL);

    EntFireByHandle(propDynamic, "SetParent", "!activator", -1, player, player)
    EntFireByHandle(propDynamic, "SetParentAttachment", "flag", -1, player, player)*/
    player.Regenerate(false)


    if (!BR_ISENABLED)
    {
        return
    }

    //death
    if (scope == null || "isAlive" in scope == false || scope.isAlive == false)
    {
        player.ForceChangeTeam(3, true)
        player.TakeDamage(99999.0, 32, player)
    }
    else if (RevivesEnabled) //Revives
    {
        player.ForceChangeTeam(2, true)
        EntFire("script_main", "RunScriptCode", "PreparePlayerRevived()", 0.0, player)
        player.AddCondEx(Constants.ETFCond.TF_COND_TELEPORTED, 10.0, null)
        player.AddCondEx(Constants.ETFCond.TF_COND_INVULNERABLE_USER_BUFF, 10.0, null)
    }
    else // Died within the first 5 seconds of start
    {
        local scope = player.GetScriptScope()

		if ("squad" in scope == false)
			return


    	scope.squad.lastSpawnEnt = Entities.FindByName(scope.squad.lastSpawnEnt, "br_spawn_" + scope.squad.spawnId)
		local spawn = scope.squad.lastSpawnEnt
    	if (spawn)
    	{
        	player.Teleport(true, spawn.GetOrigin(), true, spawn.GetAbsAngles(), true, Vector(0,0,0))
    	}
		else
		{
			spawn = Entities.FindByName(spawn, "br_spawn_" + scope.squad.spawnId)
			player.Teleport(true, spawn.GetOrigin(), true, spawn.GetAbsAngles(), true, Vector(0,0,0))
		}

		EntFire("script_main", "RunScriptCode", "PreparePlayerEarlyDeath()", 0.0, player)
    }

}

function OnGameEvent_player_team(params)
{
    if ("CheckRoundStatus" in getroottable())
        CheckRoundStatus()
}

function OnScriptHook_OnTakeDamage(params)
{

    if ("Vehicle_OnTakeDamage" in getroottable())
        Vehicle_OnTakeDamage(params)

    if (!BR_ISENABLED && BR_END_PHASE == false)
        return

    local victim = params.const_entity
    local attacker = params.attacker

    if (victim.GetClassname() != "player")
        return

    //half fall damage
    if (params.damage_type == Constants.FDmgType.DMG_FALL)
    {
        params.damage = params.damage * 0.5
    }

    //Team check
    if (IsValidPlayer(victim) && IsValidPlayer(attacker))
    {
        if ((BR_MODE_TEAMS && attacker.GetPlayerClass() == victim.GetPlayerClass() && attacker != victim))
        {
            params.damage = 0
            return
        }

        //Explosive damage nerf
        if (params.damage_type & 64)
            params.damage *= 0.85

        //Half fire damage
        if (params.damage_type & 8)
            params.damage *= 0.6

        //Half Hunstman headshot damage
        if (params.weapon && params.damage_custom == Constants.ETFDmgCustom.TF_DMG_CUSTOM_HEADSHOT && params.weapon.GetClassname() == "tf_weapon_compound_bow")
            params.damage = params.damage / 3 * 2

        //Force fire on pyros
        if (params.damage_type & 16777216 || (params.damage_type & 134217728 && NetProps.GetPropInt(params.weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex") == 348))
            victim.AddCondEx(Constants.ETFCond.TF_COND_GAS, 1.0, attacker)

        //Mark to death friendlyfire fix
        if (params.weapon && NetProps.GetPropInt(params.weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex") == 355)
        {
            victim.AddCondEx(Constants.ETFCond.TF_COND_MARKEDFORDEATH, 10.0, attacker)
        }

        //Backstabs
        if (params.weapon && params.weapon.GetClassname() == "tf_weapon_knife")
        {
            if (CanBeBackstabbed(attacker, victim))
            {
                victim.TakeDamageCustom(weapon, attacker, weapon, params.damage_force, params.damage_position, 2000.0, Constants.FDmgType.DMG_CLUB, Constants.ETFDmgCustom.TF_DMG_CUSTOM_BACKSTAB)
                victim.GetScriptScope().damageReceivedForAssist[attacker.entindex()-1] += victim.GetHealth() * 12
                params.early_out = true
            }
        }
        if (IsValidPlayer(attacker) && attacker != victim)
            victim.GetScriptScope().damageReceivedForAssist[attacker.entindex()-1] += ceil(params.damage) * 12
    }
}

function OnGameEvent_player_death(params)
{
    CheckRoundStatus()

    if ("Vehicle_OnPlayerDeath" in getroottable())
        Vehicle_OnPlayerDeath(params)

    if (!BR_ISENABLED)
        return

	local victim = GetPlayerFromUserID(params.userid)
    if (victim == null)
		return

    NetProps.SetPropBool(victim, "m_bIsCoaching", false)

    if (victim.GetScriptScope() == null || "isAlive" in victim.GetScriptScope() == false)
        return

    if (victim.GetScriptScope().medkit_model && victim.GetScriptScope().medkit_model.IsValid())
        victim.GetScriptScope().medkit_model.Kill()

    if (EarlyDeathRespawn)
    {
        EntFire("script_main", "RunScriptCode", "LateRespawn()", 1.0, victim)
        return
    }

    local attacker = GetPlayerFromUserID(params.attacker)
    local assister = GetPlayerFromUserID(params.assister)
    NetProps.SetPropInt(victim, "m_lifeState", 2)

    //Increase killstreaks
    if (attacker)
    {
        attacker.GetScriptScope().killStreak += 1
        NetProps.SetPropIntArray(attacker, "m_Shared.m_nStreaks", attacker.GetScriptScope().killStreak, 0)
    }

    //Force victim to blu and check the round status
    local victimSquad = victim.GetScriptScope().squad
    victimSquad.deathOrderArray.append(victim)
    victim.GetScriptScope().isAlive <- false
    victim.ForceChangeTeam(3, true)
    CheckRoundStatus()

    //Play Last Survivor sound if needed
    if (victimSquad.SquadAliveCount() == 1)
    {
        local rnd = RandomInt(1, 4)

        EmitSoundOnClient("Announcer.AM_LastManAlive0"+rnd, victimSquad.GetLastSurvivor())
    }
    else
    {
        victimSquad.TriggerDeathResponse()
    }

    //Drop rarest weapon
    local weapon = FindRarestWeapon(victim)
    local origin = victim.GetOrigin()

    if (weapon != null)
    {
        local propDynamic = SpawnEntityFromTable("prop_dynamic", 
        {
        // This is a table of keyvalues, which is the same way as keyvalues that are defined in Hammer
        // Key         Value
            model = "models/weapons/c_models/c_shotgun/c_shotgun.mdl",
            vscripts   = "battleroyale/battleroyale_weapon.nut",
            thinkfunction = "BobbingThink",
            origin     = Vector(origin.x, origin.y, origin.z + 64.0),
            solid       = 0,
            disableshadows = 1,
            StartDisabled  = 1,
            disablereceiveshadows = 1,
            fademaxdist = 4000,
            fademindist = 3500,
        })
        propDynamic.GetScriptScope().weapon <- weapon

        local slot = victim.ReturnWeaponTable(weapon.weaponBase.weaponID).slot

        switch (slot)
        {
        case 0: //primary
        propDynamic.GetScriptScope().ammo = victim.GetScriptScope().ammo1
        propDynamic.GetScriptScope().clip = victim.GetScriptScope().clip1
        break
        case 1: //secondary
        propDynamic.GetScriptScope().ammo = victim.GetScriptScope().ammo2
        propDynamic.GetScriptScope().clip = victim.GetScriptScope().clip2
        break
        case 2: //melee
        break
        }
    }

    //Victim keeps 50% money, spawn 30% in the world, 40% as insurance money... Wait is that 120%?

    //Drop 3 stacks of money, each represents 10%
    SpawnMoney(victim.GetCurrency() * 0.1 , Vector(origin.x, origin.y, origin.z + 60))
    SpawnMoney(victim.GetCurrency() * 0.1 , Vector(origin.x, origin.y, origin.z + 64))
    SpawnMoney(victim.GetCurrency() * 0.1 , Vector(origin.x, origin.y, origin.z + 54))
    //Insurance

    local aliveArray = []
    local deathtext = ""

    if (!attacker || attacker == victim)
        deathtext += ReturnPlayername(victim) + " has died!"
    else
        deathtext += ReturnPlayername(victim) + " has been killed by " + ReturnPlayername(attacker) + "!"


    foreach(player in victimSquad.playerArray)
    {
        if (!IsValidPlayer(player))
            continue
        
        if (player != victim)
            ClientPrint(player, 3, deathtext) 
            

        if (IsAlivePlayer(player))
            aliveArray.append(player)
    }
    //Distribute in insurance money between the players from the squad that are still alive
    foreach(player in aliveArray)
    {
        local money = ceil(victim.GetCurrency() * 0.4/aliveArray.len())
        player.AddCurrency(money)

        if (money > 0)
            ClientPrint(player, 3, FormatTextWhite("You receive ") + FormatTextCash(money) + FormatTextWhite(" as insurance"))
    }

    //Halve money
    victim.RemoveCurrency(victim.GetCurrency() * 0.5)
    ClientPrint(victim, 3, FormatTextWhite("You have died! You lose half of your money. (") + FormatTextCash(victim.GetCurrency()) + FormatTextWhite(")"))

    //Award money
    local damageArray = victim.GetScriptScope().damageReceivedForAssist
    local pool = 0
    local victimId = victim.entindex()
    for (local i = 0; i < damageArray.len(); i++)
    {
        if (victimId != i)
            pool += damageArray[i]
    }

    for (local i = 0; i < damageArray.len(); i++)
    {
        if (damageArray[i] > 0)
        {
            local player = PlayerInstanceFromIndex(i+1)
            //printl(((BATTLEROYALE_CONFIG.KILL_REWARD_PLAYER_VALUE + (BATTLEROYALE_CONFIG.KILL_REWARD_BONUS * victim.GetScriptScope().killStreak)) * (damageArray[i] / pool.tofloat())))
            if (!IsValidPlayer(player))
                continue

            if (player == victim)
                continue

            if (player == attacker) //Killer
            {
                local reward = BATTLEROYALE_CONFIG.KILL_REWARD_LAST_HIT + 
                ((BATTLEROYALE_CONFIG.KILL_REWARD_PLAYER_VALUE + (BATTLEROYALE_CONFIG.KILL_REWARD_BONUS * victim.GetScriptScope().killStreak)) * (damageArray[i] / pool.tofloat())) +
                (BATTLEROYALE_CONFIG.KILL_REWARD_BONUS_LAST_HIT * victim.GetScriptScope().killStreak)
                reward = ceil(reward).tointeger()
                player.AddCurrency(reward)
                ClientPrint(player, 3, FormatTextWhite("You were awarded ") + FormatTextCash(reward) + FormatTextWhite(" for killing an enemy"))
            }
            else //Assists
            {
                local reward = ((BATTLEROYALE_CONFIG.KILL_REWARD_PLAYER_VALUE + (BATTLEROYALE_CONFIG.KILL_REWARD_BONUS * victim.GetScriptScope().killStreak)) * (damageArray[i] / pool.tofloat())) +
                (BATTLEROYALE_CONFIG.KILL_REWARD_BONUS * victim.GetScriptScope().killStreak) + BATTLEROYALE_CONFIG.KILL_REWARD_ASSIST_EXTRA
                reward = ceil(reward).tointeger()
                player.AddCurrency(reward)
                ClientPrint(player, 3, FormatTextWhite("You were awarded ") + FormatTextCash(reward) + FormatTextWhite(" for assisting in killing an enemy"))
            }
        }
        
    }


    /*if (attacker && victim != attacker)
    {
        local reward = BATTLEROYALE_CONFIG.KILL_REWARD + (BATTLEROYALE_CONFIG.KILL_REWARD_BONUS * victim.GetScriptScope().killStreak)
        attacker.AddCurrency(reward)
        local text1 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + "You were awarded "
        local text2 = "\x07" + format("%02X%02X%02X", 122, 140, 92) + reward +"$"
        local text3 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + " for killing an enemy"
        ClientPrint(attacker, 3, text1 + text2 + text3)
    }
    if (assister) //Doesn't work
    {
        attacker.AddCurrency(250)
        ClientPrint(attacker, 3, "You were awarded 250$ for assisting in killing an enemy")
    }*/

    victim.GetScriptScope().killStreak = 0

    //Drop healthkit and ammopack
    SpawnPickup("item_healthkit_small", Vector(origin.x, origin.y, origin.z + 24))
    SpawnPickup("item_ammopack_medium", Vector(origin.x, origin.y, origin.z + 14))
}

function FindRarestWeapon(player)
{
    local scope = player.GetScriptScope()
    local weaponPrimary = scope.weapon_primary
    local weaponSecondary = scope.weapon_secondary

    if (weaponPrimary == null && weaponSecondary == null)
        return null

    if (weaponPrimary == null)
    {
        scope.weapon_secondary = null
        return weaponSecondary
    }

    if (weaponSecondary == null)
    {
        scope.weapon_primary = null
        return weaponPrimary
    }

    if (weaponPrimary.rarity.tier >= weaponSecondary.rarity.tier)
    {
        scope.weapon_primary = null
        return weaponPrimary
    }
    else
    {
        scope.weapon_secondary = null
        return weaponSecondary
    }

    return null
}

function OnGameEvent_player_buff(params)
{
	local receiver = GetPlayerFromUserID(params.userid)
    local buffer = GetPlayerFromUserID(params.buff_owner)

        if (receiver.GetPlayerClass() != buffer.GetPlayerClass())
        {
            switch (params.buff_type)
            {
            case 0:
                if (receiver.GetCondDuration(Constants.ETFCond.TF_COND_DEFENSEBUFF) < 1.3)
                    receiver.RemoveCondEx(Constants.ETFCond.TF_COND_DEFENSEBUFF, false)
                break
            case 1:
                if (receiver.GetCondDuration(Constants.ETFCond.TF_COND_OFFENSEBUFF) < 1.3)
                    receiver.RemoveCondEx(Constants.ETFCond.TF_COND_OFFENSEBUFF, false)
                break
            }
        }
        else
        {
            switch (params.buff_type)
            {
            case 0:
                receiver.AddCondEx(Constants.ETFCond.TF_COND_DEFENSEBUFF, 2.0, buffer)
                break
            case 1:
                receiver.AddCondEx(Constants.ETFCond.TF_COND_OFFENSEBUFF, 2.0, buffer)
                break
            }
        }
}

function OnGameEvent_post_inventory_application(params)
{
	if ("userid" in params)
	{
		local hPlayer = GetPlayerFromUserID(params.userid)	//grab player ID...
        NetProps.SetPropBool(hPlayer, "m_bIsCoaching", false)

        if (BR_DELETEWEAPONS)
        {
            hPlayer.DeleteWeapon(TF_WEAPONSLOTS.PRIMARY)
            hPlayer.DeleteWeapon(TF_WEAPONSLOTS.SECONDARY)
            hPlayer.DeleteWeapon(TF_WEAPONSLOTS.SLOT3)
            hPlayer.DeleteWeapon(TF_WEAPONSLOTS.SLOT4)
            hPlayer.DeleteWeapon(TF_WEAPONSLOTS.SLOT5)
            hPlayer.DeleteWeapon(TF_WEAPONSLOTS.SLOT6)
        }
		
		hPlayer.GTFW_Cleanup()	//clean up function, deletes unused weapon entities from GiveWeapon.


        EntFire("tf_wearable_razorback", "kill")
        EntFire("tf_wearable_demoshield", "kill")
        EntFire("tf_weapon_pda_engineer_destroy", "kill")
        EntFire("tf_weapon_pda_engineer_build", "kill")
        EntFire("tf_weapon_builder", "kill")
        EntFire("tf_weapon_medigun", "kill")
        EntFire("tf_weapon_sapper", "kill")
        EntFire("tf_wearable_demoshield", "kill")
        EntFire("tf_wearable_razorback", "kill")

        local cosmetic = null
        while (cosmetic = Entities.FindByClassnameWithin(cosmetic, "tf_wearable", hPlayer.GetLocalOrigin(), 128))
        {
            local ItemID = NetProps.GetPropInt(cosmetic, "m_AttributeManager.m_Item.m_iItemDefinitionIndex")
            if (ItemID == 231 || ItemID == 642 || ItemID == 405 || ItemID == 608 || cosmetic.GetModelName() == "")
                cosmetic.Kill()
        }

        if (!BR_ISENABLED)
            return

        SetBRSpeed(hPlayer)
        SetBRHealth(hPlayer)
        hPlayer.AddCustomAttribute("no double jump", 1, -1)

        //Player has upgraded! Give him back his stuff
        if (BR_REFUND_PHASE)
            return

        local scope = hPlayer.GetScriptScope()

        if (!("weapon_melee" in scope))
            return

        //melee
        if (scope.weapon_melee != null)
        {
            hPlayer.GiveBRWeapon(scope.weapon_melee)
        }
        else
        {
            GiveDefaultMelee(hPlayer)
        }
        //secondary
        if (scope.weapon_secondary != null)
        {
            hPlayer.GiveBRWeapon(scope.weapon_secondary)
            NetProps.SetPropIntArray(hPlayer, "m_iAmmo", scope.ammo2, 2)
            NetProps.SetPropInt(NetProps.GetPropEntityArray(hPlayer, "m_hMyWeapons", 1), "LocalWeaponData.m_iClip1", scope.clip2)
        }
        //primary
        if (scope.weapon_primary != null)
        {   
            hPlayer.GiveBRWeapon(scope.weapon_primary)
            NetProps.SetPropIntArray(hPlayer, "m_iAmmo", scope.ammo1, 1)
            NetProps.SetPropInt(NetProps.GetPropEntityArray(hPlayer, "m_hMyWeapons", 0), "LocalWeaponData.m_iClip1", scope.clip1)
        }
        if (scope.health_fix != hPlayer.GetHealth())
        {
            EntFireByHandle(hPlayer, "AddOutPut", "health "+ scope.health_fix, 0.0, null, null)
            //hPlayer.SetHealth(scope.health_fix)
        }

            
	}
}

function OnGameEvent_show_annotation(params)
{
}

function OnGameEvent_player_healonhit(params)
{
}

function OnGameEvent_player_disconnect(params)
{
    if ("Vehicle_OnPlayerDisconnect" in getroottable())
        Vehicle_OnPlayerDisconnect(params)

    CheckRoundStatus()
}

function OnGameEvent_scorestats_accumulated_update(params)
{
     if ("Vehicle_OnRoundReset" in getroottable())
        Vehicle_OnRoundReset(params);
}

function OnGameEvent_teamplay_restart_round(params)
{
    local ent = null
    while(ent = Entities.FindByClassname(ent, "*"))
    {
        NetProps.SetPropBool(ent, "m_bForcePurgeFixedupStrings", true)
        if (ent.GetModelName() == "models/battleroyale/player_medkit.mdl")
            ent.Kill()
    }
    local hPlayer = null
    while (hPlayer = Entities.FindByClassname(hPlayer, "player") )
    {
        hPlayer.GTFW_Cleanup()
    }

}
function OnGameEvent_stats_resetround(params)
{
    local ent = null
    while(ent = Entities.FindByClassname(ent, "*"))
    {
        NetProps.SetPropBool(ent, "m_bForcePurgeFixedupStrings", true)
        if (ent.GetModelName() == "models/battleroyale/player_medkit.mdl")
            ent.Kill()
    }
    local hPlayer = null
    while (hPlayer = Entities.FindByClassname(hPlayer, "player") )
    {
        hPlayer.GTFW_Cleanup()
    }

}

__CollectGameEventCallbacks(this)
