//This script is by Alex Turtle

//Class arrays
//Names
::TFCLASS_DISPLAYNAME <- ["Unknown", "Scout", "Sniper", "Soldier", "Demoman", "Medic", "Heavy", "Pyro", "Spy", "Engineer"]

::CTFPlayer.GiveBRWeapon <- function(weapon)
{
    if (!weapon)
        return

    local player = this

    local hWeapon = null
    if (weapon.weaponBase.weaponID != null && weapon.weaponBase.weaponID != -1)
        hWeapon = weapon.weaponBase.weaponID
    else
        hWeapon = weapon.weaponBase.name

    local gun = player.GiveWeapon(hWeapon)

    local slot = player.ReturnWeaponTable(hWeapon).slot

    //Force register weapons
    switch (slot)
    {
        case 0: //primary
        player.GetScriptScope().weapon_primary <- weapon
        NetProps.SetPropEntityArray(player, "m_hMyWeapons", gun, 0)
        break
        case 1: //secondary
        player.GetScriptScope().weapon_secondary <- weapon
        NetProps.SetPropEntityArray(player, "m_hMyWeapons", gun, 1)
        break
        case 2: //melee
        player.GetScriptScope().weapon_melee <- weapon
        //killstreak
        gun.AddAttribute("killstreak tier", 1.0, -1.0)
        NetProps.SetPropIntArray(player, "m_Shared.m_nStreaks", player.GetScriptScope().killStreak, 0)
        NetProps.SetPropEntityArray(player, "m_hMyWeapons", gun, 2)
        break

    }

    local ammo = 0
    local noReload = false
    //Add attributes
    for (local i = 0; i < weapon.attributeIndexes.len(); i++)
    {
        gun.AddAttribute(weapon.attributeIndexes[i].tf_attribute, weapon.attributeIndexes[i].start_value + (weapon.attributeValues[i] * weapon.attributeIndexes[i].increment), -1)
        //reserve ammo workaround
        if (weapon.attributeIndexes[i].tf_attribute == "maxammo secondary increased")
        {
            switch (slot)
            {
            case 0: //primary
                gun.AddAttribute("maxammo primary increased", weapon.attributeIndexes[i].start_value + (weapon.attributeValues[i] * weapon.attributeIndexes[i].increment), -1)
                ammo = NetProps.GetPropIntArray(player, "m_iAmmo", slot + 1)
                ammo *= weapon.attributeIndexes[i].start_value + (weapon.attributeValues[i] * weapon.attributeIndexes[i].increment)
                NetProps.SetPropIntArray(player, "m_iAmmo", ammo, slot + 1)
                break
            case 1: //secondary
                gun.AddAttribute("maxammo secondary increased", weapon.attributeIndexes[i].start_value + (weapon.attributeValues[i] * weapon.attributeIndexes[i].increment), -1)
                ammo = NetProps.GetPropIntArray(player, "m_iAmmo", slot + 1)
                ammo *= weapon.attributeIndexes[i].start_value + (weapon.attributeValues[i] * weapon.attributeIndexes[i].increment)
                NetProps.SetPropIntArray(player, "m_iAmmo", ammo, slot + 1)
                break
            case 2: //melee
                break
            }
        }
    }

    gun.AddAttribute("weapon burn dmg reduced", 0.5, -1)

    //Apply Australium
    if (weapon.isAustralium)
    {
        gun.AddAttribute("item style override", 1, -1)
        gun.AddAttribute("is australium item", 1, -1)
        gun.AddAttribute("loot rarity", 1, -1)
        gun.AddAttribute("set item tint RGB", 15185211.0, -1)
        gun.AddAttribute("set item tint RGB 2", 15185211.0, -1)

        NetProps.SetPropInt(gun, "m_AttributeManager.m_Item.m_iEntityQuality", 9)
    }

    //Huntsman fix
    if (weapon.weaponBase.weaponID == 56 && NetProps.GetPropInt(gun, "m_bFlipViewModel") == 0 ) {
		NetProps.SetPropInt(gun, "m_bFlipViewModel", 1)
	}
}

::CTFPlayer.DropBRWeaponInSlot <- function(slot)
{

    local weapon = null
    switch (slot)
    {
        case 0: //primary
        weapon = this.GetScriptScope().weapon_primary
        break
        case 1: //secondary
        weapon = this.GetScriptScope().weapon_secondary
        break
        case 2: //melee
        weapon = this.GetScriptScope().weapon_melee
        break
    }

    if (weapon == null)
        return

    local origin = this.GetOrigin()

    local propDynamic = SpawnEntityFromTable("prop_dynamic", 
    {
    // This is a table of keyvalues, which is the same way as keyvalues that are defined in Hammer
    // Key         Value
        model = "models/weapons/c_models/c_shotgun/c_shotgun.mdl",
        vscripts   = "battleroyale/battleroyale_weapon.nut",
        thinkfunction = "BobbingThink",
        origin     = Vector(origin.x, origin.y, origin.z + 64.0),
        solid       = 0,
        disableshadows = 1,
        StartDisabled  = 1,
        disablereceiveshadows = 1,
    })
    propDynamic.GetScriptScope().weapon <- weapon

    switch (slot)
    {
        case 0: //primary
        propDynamic.GetScriptScope().ammo = NetProps.GetPropIntArray(this, "m_iAmmo", 1)
        propDynamic.GetScriptScope().clip = NetProps.GetPropInt(NetProps.GetPropEntityArray(this, "m_hMyWeapons", 0), "LocalWeaponData.m_iClip1")
        break
        case 1: //secondary
        propDynamic.GetScriptScope().ammo = NetProps.GetPropIntArray(this, "m_iAmmo", 2)
        propDynamic.GetScriptScope().clip = NetProps.GetPropInt(NetProps.GetPropEntityArray(this, "m_hMyWeapons", 1), "LocalWeaponData.m_iClip1")
        break
        case 2: //melee
        break
    }
}



::GiveDefaultMelee <- function(player)
{
    //Fists
    local fists = player.GiveWeapon(5)
    fists.AddAttribute("killstreak tier", 1.0, -1.0)
    fists.AddAttribute("damage penalty", 0.5, -1.0)
    //No killstreak?
    if ("killStreak" in player.GetScriptScope() == false)
        player.GetScriptScope().killStreak <- 0

    NetProps.SetPropIntArray(player, "m_Shared.m_nStreaks", player.GetScriptScope().killStreak, 0)
    NetProps.SetPropEntityArray(player, "m_hMyWeapons", fists, 2)
}