//This script is by Alex Turtle

//Shove this into a player's thinker function to enable interactivity

::BR_ISENABLED <- false

//fix for the game_text channels
::channel_interval_time <- 0.5

//If you are looking for Thinker logic for each player, then you are in the right place!
::PlayerInteractionsThinker <- function()
{
    if (BR_ISENABLED != true)
        return -1


    local player = self.GetScriptScope().parent
    if (!player.IsValid())
    {
        NetProps.SetPropString(self, "m_iszScriptThinkFunction", "")
        self.Kill()
        return -1
    }

    local angles = null
    local origin = null
    //while (player = Entities.FindByClassname(player, "player") )
    //{
        local playerScope = player.GetScriptScope()
        //Healing cooldown calculations
        if (player.GetTeam() != 2 || playerScope == null || "healCooldown" in playerScope == false)
        {
            player.SetScriptOverlayMaterial("")
            return -1
        }
        
        //Calculations for assists
        playerScope.damageReceivedForAssist.apply(function(value) {
        if (value > 0) {return value-1} else {return value};
        });

        playerScope.healCooldown -= FrameTime()
        playerScope.pingBuffer -= FrameTime()

        if (playerScope.pingCount < 3)
            playerScope.pingCooldown -= FrameTime()

        if (playerScope.pingCooldown < 0.0)
        {
            playerScope.pingCount++
            playerScope.pingCooldown = 5.0
        }
        
        if (IsAlivePlayer(player) == false)
        {
            player.SetScriptOverlayMaterial("")
            return -1
        }

        //Hack to prevent player seeing their own medkit while it renders in thirdperson
        if (-3.0 < playerScope.healCooldown && playerScope.healCooldown < 0.5)
            player.RemoveCond(Constants.ETFCond.TF_COND_TAUNTING)
            
        if (playerScope.channel_cooldown_text_lastime + playerScope.channel_interval_time < Time() + playerScope.channel_cooldown_text_delay)
        {
            if (playerScope.healCooldown < 0.0)
            {
                EntFireByHandle(playerScope.cooldown_text, "AddOutput", "message Mouse3", 0.0, player, player)
                player.SetScriptOverlayMaterial("vgui/battleroyale/firstaid_on.vmt")
                //EntFireByHandle(playerScope.medkit_model, "Enable", "", -1, null, null)
                NetProps.SetPropInt(playerScope.medkit_model, "m_nRenderMode", 0)
            }
            else
            {
                EntFireByHandle(playerScope.cooldown_text, "AddOutput", "message " + DisplayStylizedCounter(BATTLEROYALE_CONFIG.HEALING_COOLDOWN - playerScope.healCooldown, BATTLEROYALE_CONFIG.HEALING_COOLDOWN, 5.0), 0.0, player, player)
                player.SetScriptOverlayMaterial("vgui/battleroyale/firstaid_off.vmt")
                NetProps.SetPropInt(playerScope.medkit_model, "m_nRenderMode", 10)
                //EntFireByHandle(playerScope.medkit_model, "Disable", "", -1, null, null)
            }

            EntFireByHandle(playerScope.cooldown_text, "Display", "", 0.0, player, player)
            playerScope.channel_cooldown_text_lastime = Time()
        }


        //Print weapon stats and squad location
        if (player.IsInspecting())
        {
            if (playerScope.lastInspect + 100 < GetFrameCount())
            {
                player.PrintCurrentWeapon()
                ShowSquadLocation(player, 8.0)
            }
        }

        angles = player.EyeAngles()
        origin = player.EyePosition()

        //Delete colision between allies

        local otherPlayer = null
        local originCheck = player.GetOrigin() //+ Vector(0, 0, 32)
        while (otherPlayer = Entities.FindByClassnameWithin(otherPlayer, "player", originCheck, 96.0))
        {
        /*local CollisionFix_traceTable =
        {
	        start = player.GetOrigin() + Vector(0, 0, 40)
            hullmin = Vector(-36, -36, -40)
            hullmax = Vector(36, 36, 40)
	        end =  player.GetOrigin() + Vector(0, 0, -4)
            ignore = worldspawn
            //mask = 33636363
        }
        
        TraceHull(CollisionFix_traceTable)
        DebugDrawBox(player.GetOrigin() + Vector(0, 0, 40), Vector(-36, -36, -44), Vector(36, 36, 44), 255, 255, 255, 255, 0.1)
        local CollisionFix_ent = null
        //Trace around the player
        if (CollisionFix_traceTable.hit && (CollisionFix_traceTable.enthit.GetClassname() == "player"))
        local CollisionFix_ent = CollisionFix_traceTable.enthit*/
        if (otherPlayer && otherPlayer != player && IsAlivePlayer(otherPlayer))
	    {
            if (player.GetPlayerClass() == otherPlayer.GetPlayerClass())
            {
                NetProps.SetPropInt(player, "m_CollisionGroup", 2)
                break
            }
        }
        else
        {
            NetProps.SetPropInt(player, "m_CollisionGroup", 4)
        }
        }

        local btn = NetProps.GetPropInt(player, "m_nButtons")
        //Ping system, man I wish we had more buttons

        if (btn & BUTTONS.IN_ATTACK3 && player.IsUsingActionSlot() && playerScope.pingBuffer < 0.0 && playerScope.pingCount > 0)
        {
        local Ping_traceTable =
        {
	        start = origin
	        end =  angles.Forward() * 5000 + origin
            ignore = player
        }

        TraceLineEx(Ping_traceTable)
        if (Ping_traceTable.hit)
            PingLocation(player, 5.0, Ping_traceTable.pos)

        playerScope.pingBuffer = 1.0
        playerScope.pingCount--
        }

        //Trace for displaying another player's health and name
        local Display_traceTable =
        {
	        start = origin
	        end =  angles.Forward() * 15000 + origin
            ignore = player
        }
        TraceLineEx(Display_traceTable)

        player.AddHudHideFlags(Constants.FHideHUD.HIDEHUD_TARGET_ID)
        if (Display_traceTable.hit)
        {
            if (BR_MODE_TEAMS && Display_traceTable.hit && Display_traceTable.enthit.GetClassname() == "player")
            { 
                if (player.GetPlayerClass() == Display_traceTable.enthit.GetPlayerClass())
                    player.RemoveHudHideFlags(Constants.FHideHUD.HIDEHUD_TARGET_ID)
            }
        }


        //General trace
        local traceTable =
        {
	        start = origin
            hullmin = Vector(-8, -8, -8)
            hullmax = Vector(8, 8, 8)
	        end =  angles.Forward() * 125 + origin
            ignore = player
        }
        

        TraceHull(traceTable)

        local ent = null
        //Trace in front of the player
        if (traceTable.hit && (traceTable.enthit.GetClassname() == "prop_dynamic" || traceTable.enthit.GetClassname() == "prop_dynamic_override" || traceTable.enthit.GetClassname() == "prop_physics" || traceTable.enthit.GetClassname() == "prop_physics_override"  || traceTable.enthit.GetClassname() == "prop_vehicle_driveable"))
            ent = traceTable.enthit
        else if (playerScope.interactibleTrigger)
            ent = playerScope.interactibleTrigger
        //Trace has hit an interactible
	    if (ent)
	    {   
            player.DisplayInformation(ent)

            if (player.IsUsingActionSlot() || btn & BUTTONS.IN_ATTACK3)
            {
                player.TryInteract(ent)
            }
            else
            {
                player.GetScriptScope().startHoldingTime <- Time()
            }   
            return -1
	    }
        //Trace has hit player
	    else if (BR_MODE_TEAMS && traceTable.hit && traceTable.enthit.GetClassname() == "player")
	    {
            local target = traceTable.enthit

            if (player.GetPlayerClass() != target.GetPlayerClass())
                return -1

            if (target.GetHealth() >= target.GetMaxHealth())
                return -1

            FirstAidMessage(player, target)
            //Heal!
            if ((player.IsUsingActionSlot() || btn & BUTTONS.IN_ATTACK3) && playerScope.healCooldown <= 0.0)
            {
                target.SetHealth(target.GetHealth() + BATTLEROYALE_CONFIG.HEALING_POWER)
                target.AddCondEx(Constants.ETFCond.TF_COND_MEGAHEAL, 1.0, player)
                local event =
                {
	                amount = BATTLEROYALE_CONFIG.HEALING_POWER
                    entindex = target.entindex()
                }

                SendGlobalGameEvent("player_healonhit", event)

                EmitSoundOnClient("HealthKit.Touch", target)
                EmitSoundOnClient("HealthKit.Touch", player)
                playerScope.healCooldown <- BATTLEROYALE_CONFIG.HEALING_COOLDOWN
                player.AddCurrency(BATTLEROYALE_CONFIG.HEALING_REWARD)
                ClientPrint(player, 3, FormatTextWhite("You were awarded ")+ FormatTextCash(BATTLEROYALE_CONFIG.HEALING_REWARD) + FormatTextWhite(" for healing ") + ReturnPlayername(target))
                ClientPrint(target, 3, FormatTextWhite("You have been healed by ") + ReturnPlayername(player))
            }
	    }
        player.GetScriptScope().startHoldingTime <- Time()
    //}

    return -1
}

//Because of how bad it is, only shows the closest ally
::ShowSquadLocation <- function(player, annotation_time)
{
    local scope = player.GetScriptScope()
    local location = null
    local length = 999999
    local squadmate = null
    local squadmateindex = null
    foreach (squadmate in scope.squad.playerArray)
    {
        if (!IsAlivePlayer(squadmate))
            continue

        local name = null
        local compareLength = (squadmate.EyePosition() - player.EyePosition()).Length()
        if (squadmate != player && (compareLength < length || name == null))
        { 
            length = compareLength
            location = squadmate.EyePosition()
            name = NetProps.GetPropString(squadmate, "m_szNetname")
            squadmateindex = squadmate.entindex()
        }
        if (name == null)
            continue

    local annotation =
    {
        id = MaxClients().tointeger() * player.entindex() * scope.squad.MaxSquadSize + 8750 + squadmateindex
	    worldPosX = location.x
        worldPosY = location.y
        worldPosZ = location.z
        follow_entindex = squadmateindex
        show_distance = true
	    lifetime =  annotation_time
        text = name
        play_sound = "vo/null.wav"
        visibilityBitfield = 1 << player.entindex()
    }

    SendGlobalGameEvent("show_annotation", annotation)

    }
}

::PingLocation <- function(player, annotation_time, location)
{
    local scope = player.GetScriptScope()
    local length = 999999
    local buffer = 0
    local squadmate = null
    foreach (squadmate in scope.squad.playerArray)
    {
        if (!IsAlivePlayer(squadmate))
            continue

        buffer += 1 << squadmate.entindex()
        
    }

    local annotation =
    {
        id = MaxClients().tointeger() * player.GetEntityIndex() * scope.squad.MaxSquadSize + 8750
	    worldPosX = location.x
        worldPosY = location.y
        worldPosZ = location.z
	    lifetime =  annotation_time
        text = "!"
        play_sound = "vo/null.wav"
        visibilityBitfield = buffer
    }
    SendGlobalGameEvent("show_annotation", annotation)
}

::CTFPlayer.PrintCurrentWeapon  <- function()
{
    local weapon = null
    local text = ""
    local value = ""
    local scope = this.GetScriptScope()

    text += "\x07" + format("%02X%02X%02X", 255, 255, 255) + "You have "
    text += "\x07" + format("%02X%02X%02X", 122, 140, 92) + this.GetCurrency() + "$\n"

    switch (this.GetActiveWeapon().GetSlot())
    {
        case 0: //primary
        weapon = scope.weapon_primary
        break
        case 1: //secondary
        weapon = scope.weapon_secondary
        break
        case 2: //melee
        if (scope.weapon_melee != null)
            weapon = scope.weapon_melee
        break

    }

    if (weapon != null)
    {
        
    text += "\x07" + format("%02X%02X%02X", weapon.rarity.color[0], weapon.rarity.color[1], weapon.rarity.color[2]) + weapon.rarity.name + " " + weapon.weaponBase.name + "\n"


    text += "\x07" + format("%02X%02X%02X", 255, 255, 255) 

    for (local i = 0; i < weapon.attributeIndexes.len(); i++)
    {
        value = weapon.attributeIndexes[i].start_value + (weapon.attributeValues[i] * weapon.attributeIndexes[i].increment)

        text += FormatAttributeDescription(value, weapon.attributeIndexes[i].description) + "\n"
    }
    }

    scope.lastInspect <- GetFrameCount()
    ClientPrint(this, 3, text)
}

::FormatAttributeDescription <- function(value, text)
{
    local string = ""
    local string2 = ""
    local index = null

    //Additive
    if (text.find("%s1") != null)
    {
        index = text.find("%s1")
        string = text.slice(0, index)
        string2 = text.slice(index + 3, text.len())
        return string + value + string2
    }
    //Percentage
    else if (text.find("%s2") != null)
    {
        index = text.find("%s2")

        string = text.slice(0, index)   
        string2 = text.slice(index + 3, text.len())
        value -= 1
        value *= 100
        return string + value + string2
    }
    //Inverted percentage
    else if (text.find("%s3") != null)
    {
        index = text.find("%s3")

        string = text.slice(0, index)
        string2 = text.slice(index + 3, text.len())
        value = 1 - value
        value *= 100
        return string + value + string2
    }
    return text
}

::FirstAidMessage <- function(player, target)
{
    local description = ""
    local value = ""
    local color = "255 255 255"
    local scope = player.GetScriptScope()

    if (scope.healCooldown <= 0.0)
        description += "\nPress MOUSE3 or ACTION SLOT to provide First Aid to " +  NetProps.GetPropString(target, "m_szNetname") + "\n('H' by default)"
    else
        description += "\nYour First Aid ability will be ready in " + format("%.2f", scope.healCooldown) + " seconds"

    if (scope.channel_cooldown_text_lastime + scope.channel_interval_time < Time() + scope.channel_cooldown_text_delay)
    {
        EntFireByHandle(scope.game_text, "AddOutput", "message " + description, 0.0, player, player)
        EntFireByHandle(scope.game_text, "Display", "", 0.0, player, player)
        scope.channel_game_text_lastime = Time()
    }

}

::CTFPlayer.TryInteract <- function(entity)
{
    local scope = entity.GetScriptScope()
    local price = 0
    if ("interact_price" in scope)
        price = scope.interact_price

    local interactTime = 0
    if ("interact_time" in scope)
        interactTime = scope.interact_time

    if (this.GetCurrency() < price)
        return
    
    if ("Interacting" in scope)
        scope.Interacting(this)

    if (this.GetScriptScope().startHoldingTime + interactTime <= Time())
    {
        this.GetScriptScope().startHoldingTime <- Time()
        if ("OnInteractSuccess" in scope)
        {
            this.RemoveCurrency(price)
            scope.OnInteractSuccess(this)
        }
    }
}

::CTFPlayer.DisplayInformation <- function(entity)
{
    local scope = entity.GetScriptScope()
    local btn = NetProps.GetPropInt(this, "m_nButtons")

    local text = ""
    local color = "255 255 255"
    local playerScope = this.GetScriptScope()

    local interactTime = 0
    if ("interact_time" in scope)
        interactTime = scope.interact_time

    local price = 0
    if ("interact_price" in scope)
        price = scope.interact_price

    if (this.IsUsingActionSlot() || btn & BUTTONS.IN_ATTACK3)
    {
        if ("DisplayInteracting" in scope && this.GetCurrency() >= price)
            text = scope.DisplayInteracting(this,  Time() - playerScope.startHoldingTime)
        else if ("DisplayCannotAfford" in scope)
            text = scope.DisplayCannotAfford(this)
    }
    else if ("DisplayInformation" in scope)
    {
        text = scope.DisplayInformation(this)
    }

    if (text == null || text == "")
        return

    if (playerScope.channel_game_text_lastime + playerScope.channel_interval_time < Time() + playerScope.channel_game_text_delay)
    {
        EntFireByHandle(playerScope.game_text, "AddOutput", "message " + text, 0.0, this, this)
        EntFireByHandle(playerScope.game_text, "Display", "", 0.0, this, this)
        playerScope.channel_game_text_lastime = Time()
    }

}