//This script is by Alex Turtle

interact_time <- 5.0
interact_price <- 1000

afk_check <- []
timer_check <- []
reviver_check <- []
attempts_check <- []
queue_check <- []
revive_cost <- []

function OnPostSpawn() 
{
    interact_time <- BATTLEROYALE_CONFIG.REVIVE_TIME
    interact_price <- 0

    local center = self.GetCenter()

    local text = SpawnEntityFromTable("point_worldtext", 
    {
        // This is a table of keyvalues, which is the same way as keyvalues that are defined in Hammer
        // Key         Value
        message      = " Revive\nStation"
        color        = "255 255 255"
        textsize     = 24
        font         = 1
        orientation  = 1
        rainbow      = 1
        origin       = Vector(center.x, center.y, center.z + self.GetBoundingMaxsOriented().z + 36.0)
    })

    NetProps.SetPropBool(self, "m_bForcePurgeFixedupStrings", true)
}

function Interacting(player)
{
    //First to die gets revived first
    if (!player.GetScriptScope().squad.IsThereDeadSquadmate() || !RevivesEnabled || player.GetCurrency() < player.GetScriptScope().squad.GetRevivePrice())
        return

    local playerOrigin = player.EyePosition()
    DispatchParticleEffect("br_coins", Vector(playerOrigin.x, playerOrigin.y, playerOrigin.z - 26.0), player.EyeAngles().Forward())
}

function OnInteractSuccess(player)
{
    if (!player.GetScriptScope().squad.IsThereDeadSquadmate() || !RevivesEnabled || player.GetCurrency() < player.GetScriptScope().squad.GetRevivePrice())
        return

    player.RemoveCurrency(player.GetScriptScope().squad.GetRevivePrice())

    local DeadMembersLeft = ReviveTeammate(player)

    attempts_check.append(DeadMembersLeft)

    AddThinkToEnt(self, "CheckAFKThinker")

    player.GetScriptScope().squad.revives += 1
}

function DisplayInformation(player)
{
    if (!RevivesEnabled)
        return "Revives are currently unavailable"

    if (player.GetScriptScope().squad.IsThereDeadSquadmate())
        return "\nCost - "+player.GetScriptScope().squad.GetRevivePrice()+"$ per teammate\n\nHold MOUSE3 or ACTION SLOT to revive your teammate\n('H' by default)"
    else
        return "Your squad is full"
}

function DisplayInteracting(player, time_elapsed)
{
    if (!RevivesEnabled)
        return "Revives are currently unavailable"

    if (player.GetCurrency() < player.GetScriptScope().squad.GetRevivePrice())
        return "You cannot afford this"

    if (player.GetScriptScope().squad.IsThereDeadSquadmate())
        return "Reviving teammate\n" + DisplayStylizedCounter(time_elapsed, interact_time, 0.5)
    else
        return "Your squad is full"
    
}

function DisplayCannotAfford(player)
{
    if (player.GetScriptScope().squad.IsThereDeadSquadmate())
        return "You cannot afford this"
    else
        return "Your squad is full"
}

function ReviveTeammate(reviver, deathQueue = null)
{
    local playerScope = reviver.GetScriptScope()

    local deathArray = deathQueue
    if (deathArray == null)
        deathArray = playerScope.squad.deathOrderArray


    for (local i = 0; i < deathArray.len(); i++)
    {
        if (deathArray[i].IsValid() == false || deathArray[i].GetScriptScope().isAlive == true)
            continue

        local revivedPlayer = deathArray[i]

        revivedPlayer.GetScriptScope().isAlive <- true
        revivedPlayer.ForceChangeTeam(2, true)
        NetProps.SetPropInt(revivedPlayer, "m_Shared.m_iDesiredPlayerClass", playerScope.squad.playerClass)
        NetProps.SetPropInt(revivedPlayer, "m_Shared.m_iClass", playerScope.squad.playerClass)
        revivedPlayer.ForceRegenerateAndRespawn()

        local reviveLocation = reviver.GetOrigin()

        revivedPlayer.Teleport(true, reviveLocation, true, reviver.EyeAngles(), false, Vector(0,0,0))
        ClientPrint(reviver, 3, "You revived " + NetProps.GetPropString(revivedPlayer, "m_szNetname"))
        EmitSoundOnClient("Building_Teleporter.Receive", reviver)
        EmitSoundOnClient("MVM.PlayerRevived", revivedPlayer)

        //Remove the dead player from the pending array
        deathArray.remove(i)

        afk_check.append(revivedPlayer)
        timer_check.append(Time())
        reviver_check.append(reviver)
        queue_check.append(deathArray.slice(0))

        return deathArray.len()
    }

    return -1
}

function FindFitReviveLocation(startpos)
{

    local searchRadius = 64
    local z = 104 + startpos.z

    while (true)
    {
        local x = RandomFloat(startpos.x - searchRadius, startpos.x + searchRadius)
        local y = RandomFloat(startpos.y - searchRadius, startpos.y + searchRadius)

        local traceTable =
        {
	        start = Vector(x, y, z + 16)
            hullmin = Vector(-40, -40, -120)
            hullmax = Vector(40, 40, 0)
	        end =  Vector(x, y, z)
        }
        TraceHull(traceTable)

        if (traceTable.hit == false)
            return Vector(x, y, z - 74)

        searchRadius += 2
        z++
    }
}

function CheckAFKThinker()
{
    for (local i = 0; i < afk_check.len(); i++)
    {
        if (IsValidPlayer(afk_check[i]) && IsAlivePlayer(reviver_check[i]))
        {
            local btn = NetProps.GetPropInt(afk_check[i], "m_nButtons")
            if (btn == 0)
            {
                if (timer_check[i] + 10.0 <= Time())
                {
                    afk_check[i].TakeDamage(9999.9, 0, null)
                    afk_check[i].TakeDamageCustom(self, self, self, Vector(0,0,0), Vector(0,0,0), 99999.9, 2048, Constants.ETFDmgCustom.TF_DMG_CUSTOM_TRIGGER_HURT)
                    ReplaceOrRefundRevive(i)
                }
            }
            else
            {
                afk_check[i].SetCondDuration(Constants.ETFCond.TF_COND_INVULNERABLE_USER_BUFF, 3.0)

                afk_check.remove(i)
                timer_check.remove(i)
                reviver_check.remove(i)
                attempts_check.remove(i)
                queue_check.remove(i)
            }
        }
        else
        {
            //Revive again
            ReplaceOrRefundRevive(i)
        }
    }

    if (afk_check.len() == 0)
        AddThinkToEnt(self, "")

    return 0.0
}

function CheckForDead(deathArray)
{
    for (local i = 0; i < deathArray.len(); i++)
    {
        if (deathArray[i].IsValid() == true && deathArray[i].GetScriptScope().isAlive == false)
            return true

        return false
    }
}

function ReplaceOrRefundRevive(index)
{
    if (CheckForDead(queue_check[index]) && attempts_check[index] > 0)
    {
        if (IsValidPlayer(reviver_check[index]))
        {
            ClientPrint(reviver_check[index], 3, "The person you revived was not responding, finding a replacement.")
            ReviveTeammate(reviver_check[index], queue_check[index])
        }
        attempts_check[index]--
    }
    else
    {
        reviver_check[index].GetScriptScope().squad.revives -= 1
        //Refund
        local text1 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + "The person you revived was not responding. "
        local text2 = "\x07" + format("%02X%02X%02X", 122, 140, 92) + reviver_check[index].GetScriptScope().squad.GetRevivePrice() +"$"
        local text3 = "\x07" + format("%02X%02X%02X", 255, 255, 255) + " has been refunded."
        ClientPrint(reviver_check[index], 3 ,text1 + text2 + text3)
        reviver_check[index].AddCurrency(reviver_check[index].GetScriptScope().squad.GetRevivePrice())
        attempts_check.remove(index)
    }

    afk_check.remove(index)
    timer_check.remove(index)
    reviver_check.remove(index)
    queue_check.remove(index)
}