//This script is by Alex Turtle

interact_time <- 2.0

function OnPostSpawn() 
{
    EntFireByHandle(self, "AddOutput", "OnStartTouch !self:RunScriptCode:StartTouch():0:-1", 0.0, self, self)
    EntFireByHandle(self, "AddOutput", "OnEndTouch !self:RunScriptCode:EndTouch():0:-1", 0.0, self, self)
}

function StartTouch()
{
    if (BR_ISENABLED == false)
        return

    local player = activator
    player.GetScriptScope().interactibleTrigger <- self
}

function EndTouch()
{
    if (BR_ISENABLED == false)
        return

    local player = activator
    player.GetScriptScope().interactibleTrigger <- null
}

function OnInteractSuccess(player)
{
    local playerScope = player.GetScriptScope() 
    local weapon = null

    switch (player.GetActiveWeapon().GetSlot())
    {
        case 0:
            weapon = playerScope.weapon_primary
            playerScope.weapon_primary = null
            player.DeleteWeapon(TF_WEAPONSLOTS.PRIMARY)
            break
        case 1:
            weapon = playerScope.weapon_secondary
            playerScope.weapon_secondary = null
            player.DeleteWeapon(TF_WEAPONSLOTS.SECONDARY)
            break
        case 2:
            weapon = playerScope.weapon_melee
            playerScope.weapon_melee = null
            GiveDefaultMelee(player)
            break
    }

    local propPhysics = SpawnEntityFromTable("prop_physics_override", 
    {
        // This is a table of keyvalues, which is the same way as keyvalues that are defined in Hammer
        // Key         Value
        model = weapon.weaponBase.model,
        origin     = self.GetOrigin(),
        solid       = 2,
        disableshadows = 1,
    })
    NetProps.SetPropInt(propPhysics, "m_CollisionGroup", 2)
}

function DisplayInformation(player)
{
    return "Hold MOUSE3 or ACTION SLOT to sacrifice your weapon\n('H' by default)"
}

function DisplayInteracting(player, time_elapsed)
{
    if (player.GetActiveWeapon().GetClassname() != "tf_weapon_fists")
        return "Sacrificing\n" + DisplayStylizedCounter(time_elapsed, interact_time, 0.5)
    else
        return "You are not holding any weapon"
}