//This script is by Alex Turtle

weapon <- null
particles <- null
//TimeSpawned <- 0
IsActive <- false

TF_GLOW <- null

interact_time <- 0.0
interact_price <- 0.0

//ammo
ammo <- null
clip <- null

function BobbingThink()
{
    if (weapon == null)
        return
    
    local angles = self.GetAbsAngles()
    self.SetAbsAngles(QAngle(angles.x, angles.y+1, angles.z))
    return 0.033
}

function OnPostSpawn()
{
    local origin = self.GetOrigin()

    EntFireByHandle(self, "AddOutput", "targetname br_weapon_"+ self.entindex(), 0.0, self, self)

    self.SetSkin(weapon.weaponBase.skin)

    local effect = weapon.rarity.particle


    particles <- SpawnEntityFromTable("info_particle_system", 
    {
        // This is a table of keyvalues, which is the same way as keyvalues that are defined in Hammer
        // Key         Value
        effect_name = effect,
        start_active = 1,
        origin     = Vector(origin.x, origin.y, origin.z)
    })

    particles.Teleport(true, Vector(origin.x, origin.y, origin.z-58.0), false, QAngle(0,0,0), false, Vector(0,0,0))
    TimeSpawned <- GetFrameCount()
    self.SetSolidFlags(0)
    self.SetSolid(2)
    NetProps.SetPropInt(self, "m_CollisionGroup", 2)

    EntFireByHandle(self, "FireUser4", "", 1.3, self, self)
    self.SetModel(weapon.weaponBase.model)

    NetProps.SetPropBool(self, "m_bForcePurgeFixedupStrings", true)
}

function InputFireUser4() //On Animation ended
{
    EntFireByHandle(particles, "Kill", "", 0.0, self, self)
    EntFireByHandle(self, "Enable", "", 0.0, self, self)

    local color = "255 255 255 255"

    /*TF_GLOW = SpawnEntityFromTable("tf_glow", 
    {
        // This is a table of keyvalues, which is the same way as keyvalues that are defined in Hammer
        // Key         Value
        target = self.GetName(),
        GlowColor = color,
        StartDisabled = 1,
        Mode = 2,
    })

    EntFireByHandle(TF_GLOW, "Enable", "", 0.01, self, self)*/

    IsActive <- true
}

function Interacting(player)
{

}

function OnInteractSuccess(player)
{
    if (!IsActive)
        return

    IsActive = false

    local slot = player.ReturnWeaponTable(weapon.weaponBase.weaponID).slot

    player.DropBRWeaponInSlot(slot)
    
    player.GiveBRWeapon(weapon)

    if (ammo != null)
        NetProps.SetPropIntArray(player, "m_iAmmo", ammo, slot+1)
    if (clip != null)
        NetProps.SetPropInt(NetProps.GetPropEntityArray(player, "m_hMyWeapons", slot), "LocalWeaponData.m_iClip1", clip)

    //FireGameEvent("localplayer_pickup_weapon", {}) 

    //TF_GLOW.Kill()
    weapon = null
    self.Kill()

    //EntFireByHandle(player, "RunScriptCode", "RefreshHUD()", 0.1, null, null);
}

/*::RefreshHUD <- function()
{
    SendGlobalGameEvent("localplayer_pickup_weapon", {}) 
}*/

function DisplayInformation(player)
{
    if (!IsActive)
        return

    local location = self.GetOrigin()
    local text = ""
    local value = ""
    local color = "255 255 255"

    text = weapon.rarity.name + " "

    text += weapon.weaponBase.name + "\n\n"
    for (local i = 0; i < weapon.attributeIndexes.len(); i++)
    {
        value = weapon.attributeIndexes[i].start_value + (weapon.attributeValues[i] * weapon.attributeIndexes[i].increment)

        if (weapon.attributeIndexes[i].description != "" || weapon.attributeIndexes[i].description != null)
            text += FormatAttributeDescription(value, weapon.attributeIndexes[i].description) + "\n"
    }

    text += "\nPress MOUSE3 or 'ACTION SLOT' to pick up\n('H' by default)"

    return text
}

function FormatAttributeDescription(value, text)
{
    local string = ""
    local string2 = ""
    local index = null

    if (text.find("%s1") != null)
    {
        index = text.find("%s1")
        string = text.slice(0, index)
        string2 = text.slice(index + 3, text.len())
        return string + value + string2
    }
    else if (text.find("%s2") != null)
    {
        index = text.find("%s2")

        string = text.slice(0, index)   
        string2 = text.slice(index + 3, text.len())
        value -= 1
        value *= 100
        return string + value + string2
    }
    else if (text.find("%s3") != null)
    {
        index = text.find("%s3")

        string = text.slice(0, index)
        string2 = text.slice(index + 3, text.len())
        value = 1 - value
        value *= 100
        return string + value + string2
    }
    else
    {
        return text
    }
}