//This script is by Alex Turtle


//Unused
/*class BR_PLAYER
{
    index               = null
    squad               = null
	weapon_primary		= null
    weapon_secondary    = null
    weapon_melee        = null
    game_text           = null

    constructor(playerIndex, playerSquad)
	{
	    index   = playerIndex
        squad   = playerSquad

        game_text = SpawnEntityFromTable("game_text",
        {
        // This is a table of keyvalues, which is the same way as keyvalues that are defined in Hammer
        // Key         Value
        message      = ""
        color        = "255 255 255"
        })
    }
}*/

::BR_RARITY <- class
{
    tier = 0
    name = ""
    color = null
    particle = ""
    isAustralium = false
    ArrayAmount = null
    ArrayAttributesPointsMin = null
    ArrayAttributesPointsMax = null

    constructor(tier, name, color, particle, isAustralium, ArrayAmount, ArrayAttributesPointsMin, ArrayAttributesPointsMax)
	{
        this.tier = tier
        this.name = name
        this.color = color
        this.particle = particle

        this.isAustralium = isAustralium

        this.ArrayAmount = ArrayAmount
        this.ArrayAttributesPointsMin = ArrayAttributesPointsMin
        this.ArrayAttributesPointsMax = ArrayAttributesPointsMax
    }

}

::BR_CRATE <- class
{
    name               = null
    model               = null
	scale		        = null
    offset              = null
    skin                = 0
    unbox_time          = 3.0
    base_cost           = 0
    base_chance         = 0
    lootArray           = []
    hasCollision        = true
    sound               = null

    constructor(name, weight, price, lootArray, modelpath, skin, scale, offset, unbox_time, hasCollisionModel = true, soundscript = "ui.cratesmash_common")
	{
	    this.name = name
        base_chance = weight
        base_cost = price
        this.lootArray = lootArray
        model = modelpath
        this.skin   = skin
        this.scale = scale
        this.offset = Vector(offset[0], offset[1], offset[2])
        this.unbox_time = unbox_time.tofloat()
        this.sound = soundscript
        PrecacheScriptSound(soundscript)
        hasCollision = hasCollisionModel
    }
}

::BR_AIRDROP <- class
{
    name              = null
    chance             = null
	chance_modifier	    = null

    constructor(name, base_weight, weight_modifier)
	{
	    this.name = name
        chance = base_weight
        this.chance_modifier = weight_modifier
    }
}

::BR_WEAPON <- class
{
	entityIndex	= null
	weaponBase	= null
    rarity      = null
    attributeIndexes = null
    attributeValues  = null
    isAustralium = false

    commonAmount = 0
    uncommonAmount = 0
    rareAmount = 0
    legendaryAmount = 0

    commonAttributesPointsMin = 0
    commonAttributesPointsMax = 0
    uncommonAttributesPointsMin = 0
    uncommonAttributesPointsMax = 0
    rareAttributesPointsMin = 0
    rareAttributesPointsMax = 0
    legendaryAttributesPointsMin = 0
    legendaryAttributesPointsMax = 0

    constructor(baseWeapon, rarity)
	{
	    weaponBase	= baseWeapon
        this.rarity = rarity

        this.attributeIndexes = []
        this.attributeValues = []
    }

    function DistributeAttributes()
    {
        local possibleAttributes = weaponBase.possibleAttributes.slice(0)
        local ArrayAmount = this.rarity.ArrayAmount.slice(0)
        //Attribute points
        local result
        
        while (arraySum(ArrayAmount) > 0)
        {
            if (possibleAttributes.len() <= 0)
                return

            result = possibleAttributes.remove(RandomInt(0, possibleAttributes.len()-1))

            if (ArrayAmount[result.rarity] > 0)
            {
                attributeIndexes.append(result)
                attributeValues.append(RandomInt(rarity.ArrayAttributesPointsMin[result.rarity], rarity.ArrayAttributesPointsMax[result.rarity]))
                ArrayAmount[result.rarity]--
            }
        }
    }
}

::LOOT <- class
{
    lootPool = null
    weight = 1
    BR_Function = null
    parameter = null

    constructor(lootPool, weight = 1, BR_Function = null, parameter = null)
    {
        this.lootPool = lootPool
        this.BR_Function = BR_Function
        this.weight = weight
        this.parameter = parameter
    }
}


::BR_WEAPONS_BASE <- class
{
	tf_class	= null
    name        = null
	weaponID	= null
    model       = null
    rarity       = null
    skin = 0
    possibleAttributes  = []

    constructor(itemID, weaponName, modelpath, attributes, rarity, skin = 0)
	{
	    weaponID	= itemID
        name        = weaponName
        model       = modelpath
        PrecacheModel(modelpath)
        this.rarity = rarity
        possibleAttributes = array(0)
        this.skin = skin
        foreach(attribute in attributes)
        {
            possibleAttributes.append(ATTRIBUTES_POOL[attribute])
        }
    }
}

::BR_RARITY <- class
{
    tier = 0
    name = ""
    color = null
    particle = ""
    isAustralium = false
    ArrayAmount = null
    ArrayAttributesPointsMin = null
    ArrayAttributesPointsMax = null

    constructor(tier, name, color, particle, isAustralium, ArrayAmount, ArrayAttributesPointsMin, ArrayAttributesPointsMax)
	{
        this.tier = tier
        this.name = name
        this.color = color
        this.particle = particle

        this.isAustralium = isAustralium

        this.ArrayAmount = ArrayAmount
        this.ArrayAttributesPointsMin = ArrayAttributesPointsMin
        this.ArrayAttributesPointsMax = ArrayAttributesPointsMax
    }

}


class BR_ATTRIBUTES
{
    tf_attribute	= null
    description     = null
	increment 		= null
    start_value     = null
    rarity          = null 

    constructor(attribute, text, base_value, increment_value, rarity)
	{
	    tf_attribute    = attribute
        description     = text
        increment       = increment_value
        start_value     = base_value
        this.rarity     = rarity.tier
    }
}

::MANNPOWER <- class
{
    index	        = null
    display_name    = null
	modelpath 		= null
    cond            = null
    soundscript      = null 

    constructor(index, display_name, cond, modelpath, soundscript)
	{
	    this.index    = index
        this.display_name     = display_name
        this.modelpath       = modelpath
        this.cond     = cond
        this.soundscript           = soundscript
    }
}

::RUNETYPE <-
{
    RUNE_STRENGTH = 0,
    RUNE_RESIST = 1,
    RUNE_REGEN = 2,
    RUNE_HASTE = 3,
    RUNE_VAMPIRE = 4,
    RUNE_REFLECT = 5,
    RUNE_PRECISION = 6,
    RUNE_AGILITY = 7,
    RUNE_KNOCKOUT = 8,
    RUNE_KING = 9,
    RUNE_PLAGUE = 10, 
    RUNE_SUPERNOVA = 11,
}


::MANNPOWER_POOL <-
[
    MANNPOWER(RUNETYPE.RUNE_STRENGTH, "STRENGTH", Constants.ETFCond.TF_COND_RUNE_STRENGTH, "models/pickups/pickup_powerup_strength.mdl", "Powerup.PickUpStrength")
    MANNPOWER(RUNETYPE.RUNE_RESIST, "RESISTANCE", Constants.ETFCond.TF_COND_RUNE_RESIST, "models/pickups/pickup_powerup_resistance.mdl", "Powerup.PickUpResistance")
    MANNPOWER(RUNETYPE.RUNE_REGEN, "REGENERATION", Constants.ETFCond.TF_COND_RUNE_REGEN, "models/pickups/pickup_powerup_regen.mdl", "Powerup.PickUpRegeneration")
    MANNPOWER(RUNETYPE.RUNE_HASTE, "HASTE", Constants.ETFCond.TF_COND_RUNE_HASTE, "models/pickups/pickup_powerup_haste.mdl", "Powerup.PickUpHaste")
    MANNPOWER(RUNETYPE.RUNE_VAMPIRE, "VAMPIRE", Constants.ETFCond.TF_COND_RUNE_VAMPIRE, "models/pickups/pickup_powerup_vampire.mdl", "Powerup.PickUpVampire")
    MANNPOWER(RUNETYPE.RUNE_REFLECT, "REFLECT", Constants.ETFCond.TF_COND_RUNE_REFLECT, "models/pickups/pickup_powerup_reflect.mdl", "Powerup.PickUpReflect")
    MANNPOWER(RUNETYPE.RUNE_PRECISION, "PRECISION", Constants.ETFCond.TF_COND_RUNE_PRECISION, "models/pickups/pickup_powerup_precision.mdl", "Powerup.PickUpPrecision")
    MANNPOWER(RUNETYPE.RUNE_AGILITY, "AGILITY", Constants.ETFCond.TF_COND_RUNE_AGILITY, "models/pickups/pickup_powerup_agility.mdl", "Powerup.PickUpAgility")
    MANNPOWER(RUNETYPE.RUNE_KNOCKOUT, "KNOCKOUT", Constants.ETFCond.TF_COND_RUNE_KNOCKOUT, "models/pickups/pickup_powerup_knockout.mdl", "Powerup.PickUpKnockout")
    MANNPOWER(RUNETYPE.RUNE_KING, "KING", Constants.ETFCond.TF_COND_RUNE_KING, "models/pickups/pickup_powerup_king.mdl", "Powerup.PickUpKing")
    MANNPOWER(RUNETYPE.RUNE_PLAGUE, "PLAGUE", Constants.ETFCond.TF_COND_RUNE_PLAGUE, "models/pickups/pickup_powerup_plague.mdl", "Powerup.PickUpPlague")
    MANNPOWER(RUNETYPE.RUNE_SUPERNOVA, "SUPERNOVA", Constants.ETFCond.TF_COND_RUNE_SUPERNOVA, "models/pickups/pickup_powerup_supernova.mdl", "Powerup.PickUpSupernova")
]




::WEAPON_LIST_TABLE <- {}
::FillWeaponLists <- function()
{
    foreach (item in RARITY)
    {
        WEAPON_LIST_TABLE[item] <- WEAPON_POOL.filter(function(index, value) {
        return (value.rarity == item)})
    }
}

::CreateRandomBRWeapon <- function(rarity)
{
    local list = WEAPON_LIST_TABLE[rarity]

    local rnd = RandomInt(0, list.len()-1)
    local weapon = BR_WEAPON(list[rnd], rarity)

    weapon.isAustralium = rarity.isAustralium

    weapon.DistributeAttributes()
    return weapon
}