
//Pool of weapon attributes
//The constructor is as follow
//BR_ATTRIBUTES(attribute, text, base_value, increment_value, tier)
//attribute: name of the tf2 weapon attribute
//text: description to display, special format: %s1 for additive value, %s2 for percentage, %s3 for inverted percentage
//base_value: starting value
//increment_value: each "point" adds that amount to the attribute
//tier: tier of the attribute

::ATTRIBUTES_POOL <-
[
    BR_ATTRIBUTES("damage bonus HIDDEN", "+%s2% damage bonus", 1.0, 0.1, RARITY.RARE) // 0
    BR_ATTRIBUTES("clip size bonus", "+%s2% clip size", 1, 0.2, RARITY.COMMON) // 1
    BR_ATTRIBUTES("fire rate bonus", "+%s3% faster firing speed", 1, -0.1, RARITY.UNCOMMON) // 2
    BR_ATTRIBUTES("heal on kill", "+%s1 health restored on kill", 50, 25, RARITY.COMMON) // 3
    BR_ATTRIBUTES("minicritboost on kill", "On Kill: Gain Mini-crits for %s1 seconds", 1, 2, RARITY.COMMON) // 4
    BR_ATTRIBUTES("bleeding duration","On Hit: Bleed for %s1 seconds", -2, 1, RARITY.UNCOMMON) // 5
    BR_ATTRIBUTES("dmg bonus while half dead","%s2% increase in damage when health <50% of max", 1.1, 0.1, RARITY.COMMON) // 6
    BR_ATTRIBUTES("weapon spread bonus","%s3% more accurate", 1.0, -0.1, RARITY.UNCOMMON) // 7
    BR_ATTRIBUTES("Reload time decreased","+%s3% faster reload time", 1, -0.1, RARITY.UNCOMMON) // 8
    BR_ATTRIBUTES("melee range multiplier","%s2% increased melee attack range", 1.2, 0.15, RARITY.UNCOMMON) // 9
    BR_ATTRIBUTES("minigun spinup time decreased","%s3% faster spin up time", 1, -0.1, RARITY.RARE) // 10
    BR_ATTRIBUTES("Projectile speed increased HIDDEN","+%s2% projectile speed", 1, 0.1, RARITY.RARE) // 11
    BR_ATTRIBUTES("crit from behind","Always critical hit from behind", 0, 1, RARITY.LEGENDARY) // 12
    BR_ATTRIBUTES("minicrit vs burning player","100% minicrits vs burning players", 0, 1, RARITY.LEGENDARY) // 13
    BR_ATTRIBUTES("mod mini-crit airborne", "Mini-crits targets launched airborne", 0, 1, RARITY.LEGENDARY) // 14
    BR_ATTRIBUTES("speed buff ally","On Hit Teammate: Boosts both players' speed for several seconds", 0, 1, RARITY.LEGENDARY) // 15
    BR_ATTRIBUTES("rocket specialist", "On direct hits: rocket does maximum damage and stuns the target", 0, 1, RARITY.LEGENDARY) // 16
    BR_ATTRIBUTES("slow enemy on hit", "On Hit: 100% chance to slow target", 1, 0, RARITY.LEGENDARY) // 17
    BR_ATTRIBUTES("speed_boost_on_kill", "Gain a speed boost on kill", 1, 0, RARITY.LEGENDARY) // 18
    BR_ATTRIBUTES("spunup_damage_resistance", "%s3% damage resistance when below 50% health and spun up", 0.95, -0.1, RARITY.RARE) // 19
    BR_ATTRIBUTES("Blast radius increased", "+%s2% explosion radius", 1, 0.1, RARITY.RARE) // 20
    BR_ATTRIBUTES("dmg falloff decreased", "%s2% splash damage fall off", 0.5, 0.1, RARITY.UNCOMMON) // 21
    BR_ATTRIBUTES("increase buff duration", "+%s2% buff duration", 1, 0.25, RARITY.UNCOMMON) // 22
    BR_ATTRIBUTES("bullets per shot bonus", "+%s2% bullets per shot", 1.0, 0.1, RARITY.UNCOMMON) //23
    BR_ATTRIBUTES("rocket jump damage reduction HIDDEN", "-%s3% blast damage from rocket jumps", 1, -0.1, RARITY.UNCOMMON) //24
    BR_ATTRIBUTES("maxammo secondary increased", "+%s2% max ammo", 1.2, 0.4, RARITY.UNCOMMON) // 25
    BR_ATTRIBUTES("weapon burn dmg increased", "+%s2% afterburn damage bonus", 1.05, 0.2, RARITY.UNCOMMON) // 26
    BR_ATTRIBUTES("switch from wep deploy time decreased", "This weapon holsters %s3% faster", 0.9, -0.1, RARITY.COMMON) // 27
    BR_ATTRIBUTES("attack projectiles", "Bullets destroy rockets and grenades in-flight", 2, 0, RARITY.LEGENDARY) // 28
    BR_ATTRIBUTES("dmg from ranged reduced", "%s3% damage from ranged sources while active", 1.05, -0.1, RARITY.UNCOMMON) // 29
    BR_ATTRIBUTES("dmg pierces resists absorbs", "Attacks pierce damage resistances", 1, 0, RARITY.LEGENDARY) // 30
    BR_ATTRIBUTES("mult_player_movespeed_active", "+%s2% move speed when active", 1, 0.05, RARITY.UNCOMMON) // 31
    BR_ATTRIBUTES("increased jump height from weapon", "+%s2% jump height when active", 1, 0.1, RARITY.COMMON) // 32
    BR_ATTRIBUTES("cancel falling damage", "No fall damage", 1, 0, RARITY.LEGENDARY) // 33
    BR_ATTRIBUTES("sticky arm time bonus", "%s1 sec faster bomb arm time", 0, -0.1, RARITY.RARE) // 34
]


//Regroups attribute indexes into weapon categories for simplicity
::WEAPON_TYPE <-
{
    GENERIC = [0, 1, 2, 3, 4, 6, 12, 13, 17, 18, 27],
    SHOTGUN = [0, 1, 2, 3, 4, 6, 7, 8, 12, 13, 17, 18, 23, 27],
    HITSCAN = [0, 1, 3, 4, 6, 12, 13, 17, 18, 25, 27, 28],
    EXPLOSIVE = [0, 1, 2, 3, 4, 6, 8, 11, 13, 17, 18, 20, 27],
    STICKY = [0, 1, 2, 3, 4, 6, 8, 11, 13, 17, 18, 20, 27, 34],
    ROCKET = [1, 2, 3, 4, 6, 8, 12, 13, 17, 18, 20, 24, 27],
    MINIGUN = [2, 3, 4, 6, 7, 10, 12, 13, 17, 18, 19, 27, 28],
    FLARE = [0, 2, 3, 4, 6, 11, 12, 13, 17, 18, 25, 27],
    MANMELTER = [0, 2, 3, 4, 6, 12, 13, 17, 18, 27],
    MELEE = [0, 2, 3, 4, 6, 9, 12, 18, 27],
    KNIFE = [0, 2, 3, 4, 6, 9, 18, 27],
    AUSTRALIUM_SHOTGUN = [0, 1, 5, 7, 8, 14, 17, 18, 23, 25],
    AUSTRALIUM_HITSCAN = [0, 1, 5, 7, 8, 14, 17, 18, 25],
    AUSTRALIUM_EXPLOSIVE = [0, 1, 5, 8, 11, 14, 17, 20, 25],
    AUSTRALIUM_STICKY = [0, 1, 5, 8, 11, 14, 17, 20, 25, 34],
    AUSTRALIUM_ROCKETS = [1, 5, 8, 14, 16, 17, 20, 24],
    AUSTRALIUM_MINIGUN = [2, 3, 6, 7, 10, 12, 14, 17, 18, 19],
    AUSTRALIUM_MELEE = [0, 2, 3, 4, 5, 6, 9, 12, 18],
    AUSTRALIUM_KNIFE = [0, 2, 3, 4, 5, 6, 9, 18],
    RAY_GUN = [0, 1, 7, 25, 30],
    LIGHT_SABER = [0, 9, 31, 32, 33],
}

//Pool of available weapons - try avoiding using weapons requiring an unique HUD i.e. Cow Mangler
//Constructor is as follow
//BR_WEAPONS_BASE(itemID, weaponName, modelpath, attributes, rarity, australium_skin = 0)
//itemID: index of the weapon, use -1 if the weapon is custom, it will use the custom name instead. See give_tf_weapon/custom_weapons.nut
//weaponName: name of the weapon
//modelpath: path of the model, it will be used for the world model, not view model
//attributes: attributes that can be randomly selected for this weapon. Requires an array of indexes.
//rarity: rarity of the weapon, there are 5 levels. Refer to the rarity enum
//australium_skin: OPTIONAL - index of the weapon's australium skin. 
//Australiums are considered sidegrades for this gamemode and needs its own seperate pool


::WEAPON_POOL <-
[
    //Example of a custom weapon from give_tf_weapon/custom_weapons.nut
    //BR_WEAPONS_BASE(-1, "Medieval Crossbow", "models\workshop\weapons\c_models\c_crusaders_crossbow\c_crusaders_crossbow.mdl", WEAPON_TYPE.HITSCAN, RARITY.COMMON)

    //Common
    BR_WEAPONS_BASE(775, "Escape Plan", "models/weapons/c_models/c_pickaxe/c_pickaxe.mdl", WEAPON_TYPE.MELEE, RARITY.COMMON)
    BR_WEAPONS_BASE(348, "Sharpened Volcano Fragment", "models/weapons/c_models/c_rift_fire_axe/c_rift_fire_axe.mdl", WEAPON_TYPE.MELEE, RARITY.COMMON)
    BR_WEAPONS_BASE(38, "Axtinguisher", "models/weapons/c_models/c_axtinguisher/c_axtinguisher_pyro.mdl", WEAPON_TYPE.MELEE, RARITY.COMMON)
    BR_WEAPONS_BASE(171, "Tribalman's Shiv", "models/workshop/weapons/c_models/c_wood_machete/c_wood_machete.mdl", WEAPON_TYPE.MELEE, RARITY.COMMON)
    BR_WEAPONS_BASE(416, "Market Gardener", "models/weapons/c_models/c_market_gardener/c_market_gardener.mdl", WEAPON_TYPE.MELEE, RARITY.COMMON)
    BR_WEAPONS_BASE(449, "Winger", "models/weapons/c_models/c_winger_pistol/c_winger_pistol.mdl", WEAPON_TYPE.HITSCAN, RARITY.COMMON)
    BR_WEAPONS_BASE(22, "Pistol", "models/weapons/c_models/c_pistol/c_pistol.mdl", WEAPON_TYPE.HITSCAN, RARITY.COMMON)
    BR_WEAPONS_BASE(24, "Revolver", "models/weapons/c_models/c_revolver/c_revolver.mdl", WEAPON_TYPE.HITSCAN, RARITY.COMMON)
    BR_WEAPONS_BASE(460, "Enforcer", "models/weapons/c_models/c_snub_nose/c_snub_nose.mdl", WEAPON_TYPE.HITSCAN, RARITY.COMMON)
    BR_WEAPONS_BASE(17, "Syringe Gun", "models/weapons/c_models/c_syringegun/c_syringegun.mdl", WEAPON_TYPE.HITSCAN, RARITY.COMMON)
    BR_WEAPONS_BASE(997, "Rescue Ranger", "models/weapons/c_models/c_tele_shotgun/c_tele_shotgun.mdl", WEAPON_TYPE.HITSCAN, RARITY.COMMON)
    //BR_WEAPONS_BASE(442, "Righteous Bison", "models/weapons/c_models/c_drg_righteousbison/c_drg_righteousbison.mdl", WEAPON_TYPE.GENERIC, RARITY.COMMON)
    //BR_WEAPONS_BASE(588, "Pomson", "models/weapons/c_models/c_drg_pomson/c_drg_pomson.mdl", WEAPON_TYPE.GENERIC, RARITY.COMMON)
    BR_WEAPONS_BASE(16, "SMG", "models/weapons/c_models/c_smg/c_smg.mdl", WEAPON_TYPE.HITSCAN, RARITY.COMMON)
    BR_WEAPONS_BASE(141, "Frontier Justice", "models/weapons/c_models/c_frontierjustice/c_frontierjustice.mdl", WEAPON_TYPE.SHOTGUN, RARITY.COMMON)
    BR_WEAPONS_BASE(1103, "Back Scatter", "models/workshop/weapons/c_models/c_scatterdrum/c_scatterdrum.mdl", WEAPON_TYPE.SHOTGUN, RARITY.COMMON)

    //Uncommon
    BR_WEAPONS_BASE(326, "Back Scratcher", "models/workshop/weapons/c_models/c_back_scratcher/c_back_scratcher.mdl", WEAPON_TYPE.MELEE, RARITY.UNCOMMON)
    BR_WEAPONS_BASE(355, "Fan O'War", "models/workshop_partner/weapons/c_models/c_shogun_warfan/c_shogun_warfan.mdl", WEAPON_TYPE.MELEE, RARITY.UNCOMMON)
    //BR_WEAPONS_BASE(132, "Eyelander", "models/weapons/c_models/c_claymore/c_claymore.mdl", WEAPON_TYPE.MELEE, RARITY.UNCOMMON)
    BR_WEAPONS_BASE(56, "Huntsman", "models/weapons/c_models/c_bow/c_bow.mdl", WEAPON_TYPE.GENERIC, RARITY.UNCOMMON)
    BR_WEAPONS_BASE(39, "Flare Gun", "models/weapons/c_models/c_flaregun_pyro/c_flaregun_pyro.mdl", WEAPON_TYPE.FLARE, RARITY.UNCOMMON)
    BR_WEAPONS_BASE(351, "Detonator", "models/weapons/c_models/c_detonator/c_detonator.mdl", WEAPON_TYPE.FLARE, RARITY.UNCOMMON)
    BR_WEAPONS_BASE(10, "Shotgun", "models/weapons/c_models/c_shotgun/c_shotgun.mdl", WEAPON_TYPE.SHOTGUN, RARITY.UNCOMMON)
    BR_WEAPONS_BASE(200, "Scattergun", "models/weapons/c_models/c_scattergun.mdl", WEAPON_TYPE.SHOTGUN, RARITY.UNCOMMON)
    //BR_WEAPONS_BASE(220, "Shortstop", "models/weapons/c_models/c_shortstop/c_shortstop.mdl", WEAPON_TYPE.SHOTGUN, RARITY.UNCOMMON)
    //BR_WEAPONS_BASE(1153, "Panic Attack", "models/workshop/weapons/c_models/c_trenchgun/c_trenchgun.mdl", WEAPON_TYPE.SHOTGUN, RARITY.UNCOMMON) inconsistant with engineer and other classes
    BR_WEAPONS_BASE(425, "Family Business", "models/workshop/weapons/c_models/c_russian_riot/c_russian_riot.mdl", WEAPON_TYPE.SHOTGUN, RARITY.UNCOMMON)
    BR_WEAPONS_BASE(61, "Ambassador", "models/weapons/c_models/c_ambassador/c_ambassador.mdl", WEAPON_TYPE.HITSCAN, RARITY.UNCOMMON)
    BR_WEAPONS_BASE(45, "Force-A-Nature", "models/weapons/c_models/c_double_barrel.mdl", WEAPON_TYPE.SHOTGUN, RARITY.UNCOMMON)

    //Rare
    //BR_WEAPONS_BASE(730, "Beggar's Bazooka", "models/weapons/c_models/c_dumpster_device/c_dumpster_device.mdl", WEAPON_TYPE.GENERIC, RARITY.RARE)
    BR_WEAPONS_BASE(206, "Grenade Launcher","models/weapons/c_models/c_grenadelauncher/c_grenadelauncher.mdl", WEAPON_TYPE.EXPLOSIVE, RARITY.RARE)
    BR_WEAPONS_BASE(996, "Loose Cannon","models/weapons/c_models/c_demo_cannon/c_demo_cannon.mdl", WEAPON_TYPE.EXPLOSIVE, RARITY.RARE)
    BR_WEAPONS_BASE(1151, "Iron Bomber","models/workshop/weapons/c_models/c_quadball/c_quadball.mdl", WEAPON_TYPE.EXPLOSIVE, RARITY.RARE)
    BR_WEAPONS_BASE(740, "Scorch Shot", "models/weapons/c_models/c_scorch_shot/c_scorch_shot.mdl", WEAPON_TYPE.FLARE, RARITY.RARE)
    BR_WEAPONS_BASE(595, "Manmelter", "models/weapons/c_models/c_drg_manmelter/c_drg_manmelter.mdl", WEAPON_TYPE.MANMELTER, RARITY.RARE)
    BR_WEAPONS_BASE(127, "Direct Hit", "models/weapons/c_models/c_directhit/c_directhit.mdl", WEAPON_TYPE.ROCKET, RARITY.RARE)
    BR_WEAPONS_BASE(308, "Loch-n-Load","models/weapons/c_models/c_lochnload/c_lochnload.mdl", WEAPON_TYPE.EXPLOSIVE, RARITY.RARE)
    
    //Legendary
    BR_WEAPONS_BASE(1104, "Air Strike","models/workshop/weapons/c_models/c_atom_launcher/c_atom_launcher.mdl", WEAPON_TYPE.ROCKET, RARITY.LEGENDARY)
    BR_WEAPONS_BASE(207, "Sticky Launcher","models/weapons/c_models/c_stickybomb_launcher/c_stickybomb_launcher.mdl", WEAPON_TYPE.STICKY, RARITY.LEGENDARY)
    BR_WEAPONS_BASE(205, "Rocket Launcher", "models/weapons/c_models/c_rocketlauncher/c_rocketlauncher.mdl", WEAPON_TYPE.ROCKET, RARITY.LEGENDARY)
    BR_WEAPONS_BASE(202, "Minigun", "models/weapons/c_models/c_minigun/c_minigun.mdl", WEAPON_TYPE.MINIGUN, RARITY.LEGENDARY)
    BR_WEAPONS_BASE(424, "Tomislav", "models/weapons/c_models/c_tomislav/c_tomislav.mdl", WEAPON_TYPE.MINIGUN, RARITY.LEGENDARY)
    BR_WEAPONS_BASE(194, "Knife", "models/weapons/w_models/w_knife.mdl", WEAPON_TYPE.KNIFE, RARITY.LEGENDARY)
    BR_WEAPONS_BASE(414, "Liberty Launcher", "models/weapons/c_models/c_liberty_launcher/c_liberty_launcher.mdl", WEAPON_TYPE.ROCKET, RARITY.LEGENDARY)
    //BR_WEAPONS_BASE(130, "Scottish Resistance","models/weapons/c_models/c_scottish_resistance/c_scottish_resistance.mdl", WEAPON_TYPE.EXPLOSIVE, RARITY.RARE)

    //Experimental
    BR_WEAPONS_BASE(30666, "RAY GUN", "models/workshop/weapons/c_models/c_invasion_pistol/c_invasion_pistol.mdl", WEAPON_TYPE.RAY_GUN, RARITY.EXPERIMENTAL)
    BR_WEAPONS_BASE(30667, "LIGHTSABER", "models/workshop/weapons/c_models/c_invasion_bat/c_invasion_bat.mdl", WEAPON_TYPE.LIGHT_SABER, RARITY.EXPERIMENTAL)

    //Australium - sidegrades to the weapons with unique attributes
    //BR_WEAPONS_BASE(38, "Axtinguisher", "models/weapons/c_models/c_axtinguisher/c_axtinguisher_pyro.mdl", WEAPON_TYPE.AUSTRALIUM_MELEE, RARITY.AUSTRALIUM_UNCOMMON, 8)
    //BR_WEAPONS_BASE(132, "Eyelander", "models/weapons/c_models/c_claymore/c_claymore.mdl", WEAPON_TYPE.AUSTRALIUM_MELEE, RARITY.AUSTRALIUM_UNCOMMON, 2)
    BR_WEAPONS_BASE(194, "Knife", "models/weapons/w_models/w_knife.mdl", WEAPON_TYPE.AUSTRALIUM_KNIFE, RARITY.AUSTRALIUM_LEGENDARY, 8)
    BR_WEAPONS_BASE(202, "Minigun", "models/weapons/c_models/c_minigun/c_minigun.mdl", WEAPON_TYPE.AUSTRALIUM_MINIGUN, RARITY.AUSTRALIUM_LEGENDARY, 8)
    BR_WEAPONS_BASE(424, "Tomislav", "models/weapons/c_models/c_tomislav/c_tomislav.mdl", WEAPON_TYPE.AUSTRALIUM_MINIGUN, RARITY.AUSTRALIUM_LEGENDARY, 2)
    BR_WEAPONS_BASE(205, "Rocket Launcher", "models/weapons/c_models/c_rocketlauncher/c_rocketlauncher.mdl", WEAPON_TYPE.AUSTRALIUM_ROCKETS, RARITY.AUSTRALIUM_LEGENDARY, 8)
    BR_WEAPONS_BASE(206, "Grenade Launcher","models/weapons/c_models/c_grenadelauncher/c_grenadelauncher.mdl", WEAPON_TYPE.AUSTRALIUM_EXPLOSIVE, RARITY.AUSTRALIUM_RARE, 2)
    BR_WEAPONS_BASE(207, "Sticky Launcher","models/weapons/c_models/c_stickybomb_launcher/c_stickybomb_launcher.mdl", WEAPON_TYPE.AUSTRALIUM_STICKY, RARITY.AUSTRALIUM_LEGENDARY, 8)
    BR_WEAPONS_BASE(200, "Scattergun", "models/weapons/c_models/c_scattergun.mdl", WEAPON_TYPE.AUSTRALIUM_SHOTGUN, RARITY.AUSTRALIUM_RARE, 8)
    BR_WEAPONS_BASE(16, "SMG", "models/weapons/c_models/c_smg/c_smg.mdl", WEAPON_TYPE.AUSTRALIUM_HITSCAN, RARITY.AUSTRALIUM_UNCOMMON, 2)
    BR_WEAPONS_BASE(61, "Ambassador", "models/weapons/c_models/c_ambassador/c_ambassador.mdl", WEAPON_TYPE.AUSTRALIUM_HITSCAN, RARITY.AUSTRALIUM_UNCOMMON, 2)
    BR_WEAPONS_BASE(45, "Force-A-Nature", "models/weapons/c_models/c_double_barrel.mdl", WEAPON_TYPE.AUSTRALIUM_SHOTGUN, RARITY.AUSTRALIUM_UNCOMMON, 2)
]

