IncludeScript("battleroyale/config/loot.nut") //Do not remove

//Crate Types pool - List of available crates in the pool to be selected on Battleroyale start
//You may add new types in the list below - Each constructor is as follow:
//BR_CRATE(rarity, weight, price, modelpath, skin, scale, offset, unbox_time, hasCollisionModel = true, soundscript = "ui.cratesmash_common")

//name: full name of the crate
//weight: base chance of that crate to be selected, higher number = higher chance
//price: price to pay to open this crate
//LootArray: Contents of the crate, refer to config/loot.nut for more information
//modelpath: model of the crate
//skin: skin of the model
//scale: change the size of this model
//offset: the crate's origin isn't at the base? Insert an array with 3 values representing x y z
//unbox_time: time for a player to unbox this crate
//hasCollisionModel: OPTIONAL - true by default. If the model you selectioned has no collisions, set this to false and it will try to generate an inaccurate hitbox.
//soundscript: OPTIONAL - "ui.cratesmash_common" by default. Soundscript to play when unboxed

::CRATETYPE_POOL <-
[
    BR_CRATE("Free Crate", 100, 0, CRATE_FREE_LOOT,"models/props_frontline/ammocrate_1.mdl", 0, 1.0, [0.0, 0.0, 0.0], 2.5)
    BR_CRATE("Money Bag", 0, 0, CRATE_MONEY_LOOT,"models/passtime/duffel_bags/duffel_camo_stuffed.mdl", 0, 2.0, [0.0, 0.0, 0.0], 2.0, false)
    BR_CRATE("Rare Crate", 5, 1000, CRATE_RARE_LOOT,"models/props_island/mannco_case_small.mdl", 0, 1.2, [0.0, 0.0, 26.0], 3.0)
    BR_CRATE("Big Crate", 20, 250, CRATE_BIG_LOOT,"models/props_lunary/crate_lunary_01.mdl", 0, 1.0, [0.0, 0.0, 28.0], 3.0)
    BR_CRATE("Legendary Chest", 0, 2000, CRATE_LEGENDARY_LOOT,"models/props_island/mannco_case_small.mdl", 1, 1.4, [0.0, 0.0, 32.0], 4.0)
    BR_CRATE("Mannpower Crate", 1, 1600, CRATE_MANNPOWER_LOOT,"models/workshop/cases/invasion_case/invasion_case.mdl", 0, 1.7, [0.0, 0.0, 40.0], 4.0, false)
    BR_CRATE("Supply Bag", 5, 0, CRATE_SUPPLIES_LOOT,"models/props_frontline/mil_backpack_1.mdl", 0, 1.9, [0.0, 0.0, 0.0], 1.0)
    BR_CRATE("Australium Crate", 2, 1200, CRATE_AUSTRALIUM_LOOT,"models/workshop/cases/invasion_case/invasion_case_rare.mdl", 0, 1.4, [0.0, 0.0, 28.0], 4.0, false)
    BR_CRATE("Gold Idol", 0, 0, CRATE_GOLD_IDOL_LOOT,"models/props_custom/gold_idol_large.mdl", 0, 1.0, [0.0, 0.0, 0.0], 5.0)
]

//Airdrop pool - Once in a while, crates will drop from the sky, here's the chances of each type spawning
//You may add new types in the list below - Each constructor is as follow:
//BR_AIRDROP(crate_type, base_weight, weight_modifier)

//crate_type: name of the crate to spawn, refer to the pool above, has to be the exact spelling
//base_weight: base chance of that crate to be selected, higher number = higher chance
//weight_modifier: each time an airdrop takes place, the weight for that type of crate increaes/decreases by that number

::AIRDROP_POOL <-
[
    BR_AIRDROP("Free Crate", 60, -20)
    BR_AIRDROP("Supply Bag", 25, 0)
    BR_AIRDROP("Big Crate", 20, -10)
    BR_AIRDROP("Money Bag", 40, 5)
    BR_AIRDROP("Rare Crate", 0, 5)
    BR_AIRDROP("Legendary Chest", -25, 10)
    BR_AIRDROP("Australium Crate", 0, 5)
    BR_AIRDROP("Mannpower Crate", -40, 15)
]