::BATTLEROYALE_CONFIG <-
{
    //General
    PLAYER_HEALTH = 500 //Starting health. Default: 500
    PLAYER_SPEED = 300 //Starting speed. Default: 300
    IDEAL_PLAYER_COUNT = 24 //Amount of players to make the map feel "alive". Dome shrinks faster below this number. Default: 24

    //Cash
    STARTING_CASH = 0 //How much cash each player starts with? Default: 0
    COMPENSATION_CASH = 500 //A team has less players? Give them extra cash: 500
    KILL_REWARD_PLAYER_VALUE = 400 //Money rewarded between the assisters. Default: 400
    KILL_REWARD_LAST_HIT = 100 //How much cash do we give to the killer? Default: 100
    KILL_REWARD_ASSIST_EXTRA = 25 //Extra money for assists (on top of what they receive). Default: 25
    KILL_REWARD_BONUS = 100 //Grants additional cash based on the killstreak of the victim. i.e. that value will be multiplied by 3 if the victim had 3 killstreak. Default: 100
    KILL_REWARD_BONUS_LAST_HIT = 50 //Grants additional cash based on the killstreak of the victim. i.e. that value will be multiplied by 3 if the victim had 3 killstreak. Default: 50  


    //Dome
    BR_STARTING_RADIUS = 7000.0 //Radius, which means half of the diameter, make sure it kinds of starts outside the playable area
    BR_CENTER_POINT = [0.0, 0.0, 0.0] //Center of the playable area, XYZ values. The dome will spawn there. You are better off using an info_target inside the map with the name "br_center_point"
    BR_DOME_COLOR = "0 220 255" //RGB color for the dome. Default: 0 220 255
    BR_DOME_DESTINATION_COLOR = "0 220 255" //RGB color for the destination dome. Default: 0 220 255
    BR_DOME_STAGES = 5 //How many times does the dome shrinks before it closes in completely? Default: 5
    BR_DOME_FIRST_STAGE_TIME = 90.0 //How long before the first dome shrinks? Default: 90 seconds
    BR_DOME_STAGE_TIME = 70.0 //How long before the dome shrinks? Default: 70 seconds
    BR_DOME_FINAL_STAGE_TIME = 40.0 //How long before the final dome shrinks? Default: 40 seconds
    BR_DOME_FIRST_TRANSITION_TIME = 40.0 //For how long does the first dome shrinks? Default: 40 seconds
    BR_DOME_TRANSITION_TIME = 30.0 //For how long does the dome shrinks each phase? Default: 30 seconds
    BR_DOME_FINAL_TRANSITION_TIME = 20.0 //For how long does the final dome shrinks? Default: 20 seconds
    BR_DOME_MAX_Z = 128.0 //Relative to the center point, to avoid the dome going to the sky
    BR_DOME_MIN_Z = 0.0 //Relative to the center point, to avoid the dome going underground

    //First-aid ability
    HEALING_COOLDOWN = 30.0 //Cooldown between first-aid actions. -1 to disable. Default: 30 seconds
    HEALING_POWER = 100 //How much health you regen? Default: 100
    HEALING_REWARD = 50 //Reward for healing, can be negative. Default: 50

    //Revive Stations
    REVIVE_TIME = 5.0 //How long to hold the action button at the ambulance to revive? Default: 5.0 seconds
    REVIVE_PRICE = 250, //Base price to pay to revive a teammate. Default: 250
    REVIVE_PRICE_INCREMENT = 250 //Increase in price after each revive (per team). Default: 250
    REVIVE_MAX_PRICE = 1000 //Max price for a revive. Default: 1000

    //Airdrop
    AIRDROP_SPAWN_Z = 3000 //Z Axis of where the airdrops spawn in the sky, relative to the center point
    AIRDROP_COUNT_BASE = 1 //Base amount of airdrops to spawn
    AIRDROP_COUNT_INCREMENT = 2 //Amount of airdrops to deduct per stage remaining, it means the total decreases every time the dome shrinks

    //Solo Mode Spawns
    BR_SPAWN_Z = 4000 //Z Axis of where the players spawn in the sky, relative to the center point
    BR_SPAWN_RADIUS = 5000.0 //Radius, in solo mode, players spawn from the sky, forming a circle centered at the dome

    //Cash models/sounds
    MODEL_CASH_SMALL = "models/items/currencypack_small.mdl"
    MODEL_CASH_MEDIUM = "models/items/currencypack_medium.mdl"
    MODEL_CASH_BIG = "models/items/currencypack_large.mdl"
    SOUND_CASH_COLLECTED = "MVM.MoneyPickup"

}