GlowLocalRoomOrigins <- [];

for (local ent; ent = Entities.FindByName(ent, "glowlocal_room_*");)
	GlowLocalRoomOrigins.append(ent.GetOrigin());

// Adds a glow to the player (isolates them to a class specific room for 1 second)
// Any other player in the same room as this player will see the glow
::GlowLocal_AddPlayer <- function(player, r, g, b, a)
{
	if (player.GetPlayerClass() == 0)
		return

	if (GlowLocalRoomOrigins.len() == 0)
		ClientPrint(null, 3,"!!!FATAL ERROR!!! No preparation room detected. Have you forgotten to set the 'Entity Name Fix Up' to 'None'?")
	
	local room_origin = GlowLocalRoomOrigins[player.GetPlayerClass() - 1];
	local glow = Entities.CreateByClassname("tf_glow");
	NetProps.SetPropInt(glow, "m_nTransmitStateOwnedCounter", 1);
	glow.KeyValueFromString("target", "tf_gamerules");
	glow.KeyValueFromString("GlowColor", format("%d %d %d %d", r, g, b, a));
	glow.KeyValueFromString("StartDisabled", "0");
	glow.DispatchSpawn();
	glow.SetAbsOrigin(room_origin);	
	NetProps.SetPropEntity(glow, "m_hTarget", player);

	local scope = player.GetScriptScope();
	scope.glowlocal_origin <- player.GetOrigin();
	player.SetAbsOrigin(room_origin);
}

// Reverts player position to previous. Don't use this
::GlowLocal_Internal_RevertPlayer <- function()
{
	local player = null
	while (player = Entities.FindByClassname(player, "player") )
    {
		local scope = player.GetScriptScope()

		if ("squad" in scope == false)
			continue


    	scope.squad.lastSpawnEnt = Entities.FindByName(scope.squad.lastSpawnEnt, "br_spawn_" + scope.squad.spawnId)
		local spawn = scope.squad.lastSpawnEnt
    	if (spawn)
    	{
        	player.Teleport(true, spawn.GetOrigin(), true, spawn.GetAbsAngles(), true, Vector(0,0,0))
    	}
		else
		{
			spawn = Entities.FindByName(spawn, "br_spawn_" + scope.squad.spawnId)
			player.Teleport(true, spawn.GetOrigin(), true, spawn.GetAbsAngles(), true, Vector(0,0,0))
		}

		//fix health
    	player.SetHealth(player.GetMaxHealth() * 2)
	}
	Dome_Enable()
	EntFire("br_spawn_*", "Kill", null, 12.0)
	EntFire("script_main", "RunScriptCode", "DisableLateRespawn()", 9.0)
	EntFire("script_main", "RunScriptCode", "EnableCrates()", 0.0)
	EntFire("script_main", "RunScriptCode", "EnableRevives()", 11.0)
}